#include <stdio.h>
#include <stdlib.h>
#include <winsock.h>
#include "videosystem.h"

VS_EXPORT void __stdcall initialize_vidinfhdrA		( struct VIDINFHDR *vinf )
{
  initialize_vidinfhdr(vinf);
}
VS_EXPORT void __stdcall free_vidinfhdrA	( struct VIDINFHDR *vinf )
{
  free_vidinfhdr(vinf );
}

VS_EXPORT INT32 __stdcall load_imm_fileA	( CHAR *filename, struct VIDINFHDR *vinf )
{
  return load_imm_file( filename, vinf );
}

VS_EXPORT INT32 __stdcall load_bkg_fileA			( CHAR *filename, struct VIDINFHDR *vinf )
{
  return load_bkg_file( filename, vinf );
}

VS_EXPORT INT32 __stdcall load_imc_bkc_fileA		( CHAR *filename, struct VIDINFHDR *vinf, INT32 type)
{
  return load_imc_bkc_file( filename, vinf,type);
}

VS_EXPORT INT32 __stdcall load_imc_fileA			( CHAR *filename, struct VIDINFHDR *vinf )
{
  return load_imc_file( filename, vinf );
}

VS_EXPORT INT32 __stdcall load_bkc_fileA			( CHAR *filename, struct VIDINFHDR *vinf )
{
  return load_bkc_file( filename, vinf );
}

VS_EXPORT INT32 __stdcall load_fileA			( INT32 type, char *filename, struct VIDINFHDR *vinf )
{
  return load_file( type, filename, vinf );
}

VS_EXPORT INT32 __stdcall save_fileA			( INT32 type, char *filename, struct VIDINFHDR *vinf )
{
  return save_file(type, filename, vinf );
}

VS_EXPORT INT32 __stdcall save_imm_fileA			( char *outfilename, struct VIDINFHDR *vinf )
{
  return save_imm_file( outfilename, vinf );
}

VS_EXPORT INT32 __stdcall save_bkg_fileA			( char *outfilename, struct VIDINFHDR *vinf )
{
  return save_bkg_file( outfilename, vinf );
}

VS_EXPORT INT32 __stdcall save_bkc_fileA			( char *outfilename, struct VIDINFHDR *vinf )
{
  return save_bkc_file( outfilename, vinf );
}

VS_EXPORT INT32 __stdcall save_imc_fileA			( char *outfilename, struct VIDINFHDR *vinf )
{
  return save_imc_file( outfilename, vinf );
}



BOOL WINAPI DllMain(HINSTANCE hInstDll,DWORD fdwReason,LPVOID lpvReserved)
{
  switch (fdwReason)
  {
    case DLL_PROCESS_ATTACH:  // DLL being loaded
      break;
    case DLL_THREAD_ATTACH:
      break;
    case DLL_THREAD_DETACH:
      break;
    case DLL_PROCESS_DETACH:  // DLL being unloaded
      break;
  }
  return (TRUE);
}
