// GrabsrvDlg.cpp : implementation file
//

#include "stdafx.h"
#include <ifcapi.h>
#include <vfw.h>
#include "oleauto.h"
#include "Oaidl.h"
#include "errors.h"
#include "rpcdefs.h"
#include "headers.h"
#include "Compression.h"
class CGrab;
class CGrabsrvApp;
class CSocketEncapsulation;
class CSocketEncapsulation2;
class CMainDlg;
class CSendReceive;
class CSendReceive2;
class CFourierStat;
class CStat;
class CIniEx;
class CBogusTineServerDlg;
#include "Queue.h"
#include "Resource.h"
#include "ConfigDlg.h"
#include "SSyncSocket.h"
#include "SocketEncapsulation1.h"
#include "SocketEncapsulation2.h"
#include "JPEGCompression.h"
#include "Grabsrv.h"
#include "GrabsrvDlg.h"
#include "Grab.h"
#include "SendReceive.h"
#include "SendReceive2.h"
#include "fourierstat.h"
#include "IniEx.h"
#include "stat.h"
#include "BogusTineServerDlg.h"
#include "OrientationHelper.h"

// _variant_t, _bstr_t only
#include <comdef.h> 


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainDlg dialog
//
// This is the main dialog of the Grabber server application. In principle, this class 
// controls the whole application. All the other classes are just helper classes for
// this main class.
//
// In addition, the CAboutDlg class is also in this cpp file, because the class wizard
// generated it this way.
//

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainDlg dialog

/////////////////////////////////////////////////////////////////////////////
// 
// Construction of the class
//
CMainDlg::CMainDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMainDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMainDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pApp = NULL;
	m_bLossyEnabled = FALSE;

	m_sCurCamName = "DummyCam";
	m_sCurCamID = "0x11223366";
	m_iCurCamWidth = 768;
	m_iCurCamHeight = 574;
	m_iCurCamBPP = 8;
	m_iCurCamPort = 3;
	m_dCurCamScale = 1.000;
	m_iCurCamPRef = 1000;
	m_iCurCamNRef = 0;
	m_sCurCamOrient = "NORM"; 
	m_iCurCamTrigger = TRUE;
	m_iCurCamTrigMod5 = FALSE;
	
	m_tCurCamStartTime = CTime::GetCurrentTime();

	m_sNextCamName = "TestCam";
	m_sNextCamID = "0x11223366";
	m_iNextCamWidth = 768;
	m_iNextCamHeight = 574;
	m_iNextCamBPP = 8;
	m_iNextCamPort = 3;
	m_dNextCamScale = 1.000;
	m_iNextCamPRef = 1000;
	m_iNextCamNRef = 0;
	m_sNextCamOrient = "NORM"; 
	m_iNextCamTrigger = TRUE;
	m_iNextCamTrigMod5 = FALSE;

}

/////////////////////////////////////////////////////////////////////////////
// 
// DoDataExchange: this function is generated by Visual C++ class wizard.
//
void CMainDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMainDlg)
	DDX_Control(pDX, IDC_CHECK6, m_CCheckNewCamTriggerMod5);
	DDX_Control(pDX, IDC_CHECK4, m_CCheckCurCamTriggerMod5);
	DDX_Control(pDX, IDC_CHECK5, m_CCheckNewCamExternalTrigger);
	DDX_Control(pDX, IDC_CHECK2, m_CCheckCurCamExternalTrigger);
	DDX_Control(pDX, IDC_STATIC_LOSSYENABLED1, m_CStaticLossyEnabled1);
	DDX_Control(pDX, IDC_STATIC_LOSSYENABLED, m_CStaticLossyEnabled);
	DDX_Control(pDX, IDC_CHECK1, m_CCheckLossyEnabled);
	DDX_Control(pDX, IDC_EDIT_TINEACTIVE, m_CEditTINEActive);
	DDX_Control(pDX, IDC_EDIT_NEWCAMWIDTH, m_CEditNewCamWidth);
	DDX_Control(pDX, IDC_EDIT_NEWCAMSCALE, m_CEditNewCamScale);
	DDX_Control(pDX, IDC_EDIT_NEWCAMPREF, m_CEditNewCamPRef);
	DDX_Control(pDX, IDC_EDIT_NEWCAMPORT, m_CEditNewCamPort);
	DDX_Control(pDX, IDC_EDIT_NEWCAMNREF, m_CEditNewCamNRef);
	DDX_Control(pDX, IDC_EDIT_NEWCAMORIENT, m_CEditNewCamOrient);
	DDX_Control(pDX, IDC_EDIT_NEWCAMNAME, m_CEditNewCamName);
	DDX_Control(pDX, IDC_EDIT_NEWCAMID, m_CEditNewCamID);
	DDX_Control(pDX, IDC_EDIT_NEWCAMHEIGHT, m_CEditNewCamHeight);
	DDX_Control(pDX, IDC_EDIT_NEWCAMBPP, m_CEditNewCamBPP);
	DDX_Control(pDX, IDC_EDIT_LOSSYCLIENTS, m_CEditLossyClients);
	DDX_Control(pDX, IDC_EDIT_CURCAMWIDTH, m_CEditCurCamWidth);
	DDX_Control(pDX, IDC_EDIT_CURCAMSCALE, m_CEditCurCamScale);
	DDX_Control(pDX, IDC_EDIT_CURCAMNREF, m_CEditCurCamNRef);
	DDX_Control(pDX, IDC_EDIT_CURCAMNAME, m_CEditCurCamName);
	DDX_Control(pDX, IDC_EDIT_CURCAMID, m_CEditCurCamID);
	DDX_Control(pDX, IDC_EDIT_CURCAMHEIGHT, m_CEditCurCamHeight);
	DDX_Control(pDX, IDC_EDIT_CURCAMPREF, m_CEditCurCamPRef);
	DDX_Control(pDX, IDC_EDIT_CURCAMPORT, m_CEditCurCamPort);
	DDX_Control(pDX, IDC_EDIT_CURCAMORIENT, m_CEditCurCamOrient);
	DDX_Control(pDX, IDC_EDIT_CURCAMBPP, m_CEditCurCamBPP);
	DDX_Control(pDX, IDC_EDIT6_NumClients, m_CEditNumClients);
	DDX_Control(pDX, IDC_EDIT5, m_CEditHeartbeat);
	DDX_Control(pDX, IDC_EDIT3, m_CEditFramerate);
	DDX_Control(pDX, IDOK, m_ButtonClose);
	DDX_Control(pDX, IDC_BUTTONSTOPGRABBING, m_CButtonStopGrabbing);
	DDX_Control(pDX, IDC_BUTTONSTARTGRABBING, m_CButtonStartGrabbing);
	DDX_Control(pDX, IDC_BUTTONCONFIG, m_CButtonConfig);
	DDX_Control(pDX, IDC_EDIT2, m_CEditStatus);
	DDX_Control(pDX, IDC_EDIT1, m_CEditServerMessages);
	DDX_Control(pDX, IDC_SRVCTRL1, m_CTineServer);
	//}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////
// 
// Message map: this part is generated by Visual C++ class wizard.
//

BEGIN_MESSAGE_MAP(CMainDlg, CDialog)
	//{{AFX_MSG_MAP(CMainDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTONCONFIG, OnButtonConfig)
	ON_BN_CLICKED(IDC_BUTTONSTARTGRABBING, OnButtonStartGrabbing)
	ON_BN_CLICKED(IDC_BUTTONSTOPGRABBING, OnButtonStopGrabbing)
	ON_COMMAND(ID_NOTIFY_GRABBED, OnNotifyGrabbed)
	ON_BN_CLICKED(IDOK, OnButtonClose)
	ON_WM_SHOWWINDOW()
	ON_MESSAGE( ID_REMOVE_CLIENT, OnRemoveClient)
	ON_WM_SYSCOMMAND()
	ON_WM_KEYDOWN()
	ON_WM_QUERYENDSESSION()
	ON_WM_ENDSESSION()
	ON_MESSAGE( ID_START_GRABBING, OnMessageStartGrabbing)
	ON_MESSAGE( ID_STOP_GRABBING, OnMessageStopGrabbing)
	ON_MESSAGE( ID_UPDATE_GRABBING, OnMessageUpdateGrabbing)
	ON_MESSAGE( ID_CLOSE_SERVER, OnMessageCloseServer)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainDlg message handlers

// some forward declarations, functions are found in winsrv32.dll (TINE)

extern "C" {

__declspec(dllexport) short PASCAL SetMinimumPollingRate(short mpr);

__declspec(dllexport) short PASCAL RegisterFecName(char *name,char *desc,char *loc,char *hdw,char *resp,short port);

__declspec(dllexport) short PASCAL RegisterFecNameEx(char *name,char *desc,char *loc,char *hdw,char *resp,short port,char *context);

__declspec(dllexport) int PASCAL SetBurstLimit(int npackets);

__declspec(dllexport) int PASCAL SetWorkAreaSize(int siz);

__declspec(dllexport) int PASCAL SetCycleDelay(int msecs);

__declspec(dllexport) short PASCAL ScheduleProperty(char *eqm, char *prp);

}

/////////////////////////////////////////////////////////////////////////////
//
// In the OnInitDialog function all initialization that is needed before the
// main dialog pops up is done. All required member variables are initialized 
// and the TINE, ITEX, Network (Socket) and Compression codec subsystems are
// initialized.
//
BOOL CMainDlg::OnInitDialog()
{
    BOOL ret;

	m_bGrabbingCanBeStarted = FALSE;
    // call base class
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// initialize important member variables
	m_pOutputFmt = NULL;
    m_pCodec = NULL;
	m_pGrab = NULL;
	m_pOutputFmt = NULL;
	m_pAktFrameData = NULL;
	m_bFourierUpdate = FALSE;
	m_pIniFile = NULL;
	m_pGrabQueue = NULL;
	m_pJPEGCompression = NULL;
	m_pJPEGFrameData = NULL;
	m_nTimer = 0;

    m_iGrabWidth = 0;
	m_iGrabHeight = 0;

    // initialize configuration class and load config from file
    BOOL ret7 = InitializeIniFile();
	if (ret7 == FALSE)
	{
     AfxMessageBox("Could not initialize config file. This is a severe error. Program must quit.", MB_ICONEXCLAMATION | MB_OK);
	 OnButtonClose();
	 return TRUE;
	}

	/* initialize camera settings */

	m_iJPEGQuality = m_pIniFile->GetValueInt("DEFAULT", "JPEGQuality", 30);

	m_sCurCamName = m_pIniFile->GetValue("CameraSettings", "Name", "DefaultCamName");
	m_dCurCamScale = m_pIniFile->GetValueDouble("CameraSettings", "Scale", 1.0000);
	m_sCurCamOrient = m_pIniFile->GetValue("CameraSettings", "Orientation", "NORM");
	m_sCurCamID = m_pIniFile->GetValue("CameraSettings", "CAMID", "0x0"); 

	m_iCurCamNRef = m_pIniFile->GetValueInt("CameraSettings", "NegativeReference", 0);
	m_iCurCamPRef = m_pIniFile->GetValueInt("CameraSettings", "PositiveReference", 1000);

	m_iCurCamWidth = m_pIniFile->GetValueInt("CameraSettings", "Width", 768); 
	m_iCurCamHeight = m_pIniFile->GetValueInt("CameraSettings", "Height", 574); 
	m_iCurCamBPP = m_pIniFile->GetValueInt("CameraSettings", "BPP", 8); 
	m_iCurCamPort = m_pIniFile->GetValueInt("CameraSettings", "LocalCamPort", 0); 
    m_tCurCamStartTime = CTime::GetCurrentTime();

	/* put into fields */

	/*
	m_CEditCurCamName.SetWindowText( (LPCTSTR) m_sCurCamName );
	m_CEditCurCamOrient.SetWindowText( (LPCTSTR) m_sCurCamOrient );
	m_CEditCurCamID.SetWindowText( (LPCTSTR) m_sCurCamID );

	CString tmp;

	tmp.Format("%f", m_dCurCamScale );
	m_CEditCurCamScale.SetWindowText( (LPCTSTR) tmp );

	tmp.Format("%d", m_iCurCamNRef );
	m_CEditCurCamNRef.SetWindowText( (LPCTSTR) tmp );

	tmp.Format("%d", m_iCurCamPRef );
	m_CEditCurCamPRef.SetWindowText( (LPCTSTR) tmp );

	tmp.Format("%d", m_iCurCamWidth );
	m_CEditCurCamWidth.SetWindowText( (LPCTSTR) tmp );

	tmp.Format("%d", m_iCurCamHeight );
	m_CEditCurCamHeight.SetWindowText( (LPCTSTR) tmp );

	tmp.Format("%d", m_iCurCamBPP );
	m_CEditCurCamBPP.SetWindowText( (LPCTSTR) tmp );

	tmp.Format("%d", m_iCurCamPort );
	m_CEditCurCamPort.SetWindowText( (LPCTSTR) tmp );
	*/

    /* initialize spot data to default values */
    m_fXMean = -1;
	m_fYMean = -1;
	m_fXRms = -1;
	m_fYRms = -1;

	m_tServerStartTime = CTime::GetCurrentTime();

	// set some controls to default values
	m_CEditServerMessages.SetWindowText("Messages:\r\n");
	m_CEditHeartbeat.SetWindowText("");

    // get ITEX (PCVision card) settings from registry 

    int boardno = m_pIniFile->GetValueInt("DEFAULT", "BOARDNUMBER", 0);
    int sysno = m_pIniFile->GetValueInt("DEFAULT", "SYSTEMNUMBER", 0);

    BOOL initFailed = FALSE;

    // initialize grabbing subsystem and print error
	// if it could not be initialized

	m_pGrab = NULL;
	ret = InitializeITEXGrabber();
    if (ret == TRUE) 
	  PrintServerMessage(CString("Successful initialized ITEX grabber (PCVision card)."));
       else
	  {
       AfxMessageBox(CString("Could not initialize ITEX grabber (PCVision card) !"), MB_ICONEXCLAMATION | MB_OK );
	   initFailed = TRUE;
	   m_pGrab = NULL;
	  }

    // initialize compression codec
	// and print success or error message
    m_pCodec = NULL;
    ret = InitializeCompressionCodec(m_iGrabWidth, m_iGrabHeight, m_iGrabBpp);
    if (ret == TRUE) 
		PrintServerMessage("Successful initialized compression codec.");
	else
	{
		AfxMessageBox("Could not initialize compression codec.", MB_ICONEXCLAMATION | MB_OK );
		initFailed = TRUE;
    }

    // initialize TINE subsystem
	// and print success or error message
	ret = InitializeTine();
    if (ret == TRUE) 
	  PrintServerMessage("Successful initialized TINE.");
       else
	  {
       AfxMessageBox("Could not initialize TINE control connections !", MB_ICONEXCLAMATION | MB_OK );
	   initFailed = TRUE;
	  }

    // obtain network settings from config class
    int port = m_pIniFile->GetValueInt( "DEFAULT", "LISTENPORTNUMBER", 31777);
	int maxclients = m_pIniFile->GetValueInt( "DEFAULT", "MAXCLIENTS", 255);
    int port2 = m_pIniFile->GetValueInt( "DEFAULT", "LISTENPORTNUMBERLOSSY", 31778);
	int maxclients2 = m_pIniFile->GetValueInt( "DEFAULT", "MAXCLIENTSLOSSY", 255);
    int enabled2 = m_pIniFile->GetValueInt( "DEFAULT", "LOSSYENABLED", 1);
    
	if (enabled2 == 1) m_bLossyEnabled = TRUE; else m_bLossyEnabled = FALSE;

	CString tine_frame_eqp = m_pIniFile->GetValue("DEFAULT", "TINEFRAMEEQPNAME", "");
	
	// initialize network (socket) subsystem
	// and print success or error message
    ret = InitializeNetwork(port, maxclients, enabled2, port2, maxclients2, tine_frame_eqp, (m_iGrabWidth*m_iGrabHeight*m_iGrabBpp/8)); 
	if (ret == TRUE)
	{
		CString msg;
		msg.Format("Successful initialized Sockets.");
	    PrintServerMessage(msg);
	}
       else
	  {
       AfxMessageBox("Could not initialize network subsystem !", MB_ICONEXCLAMATION | MB_OK );
	   initFailed = TRUE;
	  }

	AdjustCurrentCameraDisplayedSettings();

	if (initFailed == FALSE)
	{
		m_bGrabbingCanBeStarted = TRUE;
		m_CButtonStartGrabbing.EnableWindow(TRUE);
		m_CButtonStopGrabbing.EnableWindow(FALSE);

		// automatically start up grabbing if '/a' or '/A' is the first parameter 
		// on the command line
		CString stCmdLine = GetCommandLine();
		int n = stCmdLine.Find('/', 0);
		char c = stCmdLine.GetAt(n+1);
		if (c == 'a' || c == 'A') 
		{
			::Sleep(2000);
			OnButtonStartGrabbing();
		}

    }
	 else
	{
	   m_CButtonStartGrabbing.EnableWindow(FALSE);
	   m_CButtonStopGrabbing.EnableWindow(FALSE);
    }

    m_nTimer = SetTimer(WM_TIMER_SETENVVAR, 5000, 0); 

	m_bTineTransferRunning = FALSE;
	UpdateTineTransferControl();


    m_bDeadManFlipFlopIsActive = FALSE; // is not yet started
	m_bDeadManFlipFlopRunning = TRUE; // should start 
    m_pDeadManFlipFlopThread = AfxBeginThread((AFX_THREADPROC) threadDeadManFlipFlopStatic, this); //, THREAD_PRIORITY_TIME_CRITICAL

	AdjustNextCameraDisplayedSettings();

	return TRUE;  
}


/////////////////////////////////////////////////////////////////////////////
//
// In this function all messages are printed on the Messages CEdit field on 
// the main dialog. If there are more than 99 messages, clear one message
// before putting a new one.
//
void CMainDlg::PrintServerMessage(CString message)
{
  CString str;
  CString brk = CString("\r\n"); // break at end of line

  // get current time and date
  CTime time3;  
  time3 = CTime::GetCurrentTime();

  // create time and date string
  CString timestr = time3.Format("%d.%m.%Y %H:%M:%S ");
  
  // get old messages from control
  m_CEditServerMessages.GetWindowText(str);

  int numlines = 0;
  int pos = 0;
  int foundpos;

  while( (foundpos = str.Find( "\r\n", pos) ) != -1)
  {
   pos = foundpos + 2;
   numlines++;
  }

  if (numlines > 99)
  {
   str = str.Right( str.GetLength() - str.Find("\r\n", 0 ) - 2 );
  }

  // add message
  str += timestr;
  str += message;
  str += brk;

  // put the text back on the control
  m_CEditServerMessages.SetWindowText( str );

  // scroll to bottom of CEdit field (always display the last message)
  m_CEditServerMessages.LineScroll( m_CEditServerMessages.GetLineCount() );

  
}


///////////////////////////////////////////////////////////////////////////////
//
// The OnPaint function was generated by the Visual C++ class wizard.
//
//  If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
//
void CMainDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

///////////////////////////////////////////////////////////////////////////////
//
// The OnQueryDragIcon function was generated by the Visual C++ class wizard.
//
// The system calls this to obtain the cursor to display while the user drags
// the minimized window.
//
HCURSOR CMainDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

///////////////////////////////////////////////////////////////////////////////
//
// This function is called via a Windows message whenever a new frame is 
// grabbed by the CGrab class. The frame is fetched, compressed and send
// out to all connected clients via the thread_sendfunction(). In addition,
// some variables like framerate and heartbeat are drawn on the main dialog.
// The spot size and center is calculated, too.
//
void CMainDlg::OnNotifyGrabbed()
{
	static int first=-1;
	static int num=0;
	VIDHDR vidH;
	unsigned char *imagedata=NULL;
	static _timeb starttime;
	CString orientation;
	CString cportstr;

    // notify function is running from now on 
	m_bNotifyRunning = TRUE;

    //CString msg5;
	//msg5.Format("%d", m_pGrabQueue->getSize() );
	//m_CEditGrabQueue.SetWindowText( (LPCTSTR) msg5 );

	// drop frames if there are too many
	int num_in_queue = m_pGrabQueue->GetSize();
	if (num_in_queue > 5)
	{
		for (int i=0;i<num_in_queue-1;i++)
		{
		  void *tmpptr = (void *) m_pGrabQueue->RemoveHead();
		  if (tmpptr != NULL) memman.sw_free( tmpptr );
		}
	}

    char *frame = (char *) m_pGrabQueue->RemoveHead();
	if (frame == NULL)
	{
		m_bNotifyRunning = FALSE;
		return;
	}

	memman.memcpysw( (char *) &vidH, frame, sizeof(VIDHDR) );

    imagedata = (unsigned char *) frame + sizeof(VIDHDR);

	if (CheckEffectiveBits( imagedata, vidH.bpp, vidH.bpp_effective, vidH.widthframe*vidH.heightframe) == FALSE)
	{
		static int x=0;

		if (x == 0)
		{
			CString msg;
			msg.Format("%dbpp: out of effective bits range (ebr=%d) bits found (fno=%lu)!", vidH.bpp, vidH.bpp_effective, vidH.frameno);
			PrintServerMessage(msg);
			PrintServerMessage("This warning will only appear once! It is now disabled.");
			x=1;
		}
		
	}



    // get the proper scale value for the cameraport and put it into the video header
	// also: get proper orientation information for the camera port
	vidH.scale = m_dCurCamScale;
	orientation = m_sCurCamOrient;
	cportstr = m_sCurCamName;

    //CString msg5;
	//msg5.Format("%s", orientation);
	//m_CEditGrabQueue.SetWindowText( (LPCTSTR) msg5 );   
    
    char *tmpbuf = NULL;
    if (orientation != CString("NORM")) // shall we rotate or mirror ? 
	{
      // allocate temp memory buffer in order to store the rotated or mirrored frame
	  tmpbuf = (char *) memman.sw_malloc( (vidH.widthframe*vidH.heightframe*vidH.bpp/8)+sizeof(VIDHDR) );
	  if (tmpbuf != NULL)
 	  {
       // set pointer to write the transformed data
	   char *writedata = tmpbuf + sizeof(VIDHDR);
	   
	   // call transformation function
	   COrientationHelper::CalcOrientation( (char *) writedata, (char *) imagedata, orientation, vidH.widthframe, vidH.heightframe, vidH.bpp ); 

       // if rotate by 90 or 270: swap width and height of the image 
       if (orientation == CString("ROT90CW") || orientation == CString("ROT270CW") || orientation == CString("ROT90CWMIRRHORIZ"))
	   {
	    UINT tmp;
	    tmp = vidH.heightframe;
	    vidH.heightframe = vidH.widthframe;
	    vidH.widthframe = tmp;
       }
 
       // set imagedata pointer to the newly transformed data 
       imagedata = (unsigned char *) writedata;
	  }
    }
    

	// calculate a write position in the m_pAktFrameData memory location
	char *writepos;

	writepos = (char *) m_pAktFrameData;
    writepos += sizeof(VIDHDR);
    writepos += m_pOutputFmt->biSize;

    // compress frame into the write position
	BOOL ret = m_pCodec->CompressFrame((char *) imagedata, writepos);
	
	if (m_bLossyEnabled == TRUE)
	{
	 m_iJPEGFrameLength = m_iJPEGMaxFrameLength;

	 BOOL ret1 = m_pJPEGCompression->Compress((char *) imagedata, vidH, m_pJPEGFrameData, &m_iJPEGFrameLength, cportstr);
	}

    // get output format of frame
	m_pCodec->GetOutputFormat( m_pOutputFmt );

    // calculate length parameters of video header
	vidH.len_data = m_pOutputFmt->biSizeImage;
	vidH.len_fmthdr = m_pOutputFmt->biSize;
	vidH.len_total = sizeof(VIDHDR)+vidH.len_fmthdr+vidH.len_data;
    vidH.bpp = 8;

    // check whether frame was really compressed (not bigger than original frame)
	if (vidH.len_total > ((vidH.widthframe*vidH.heightframe*vidH.bpp/8)+sizeof(VIDHDR)))
	{
	 // compression ratio is not okay
	 // so we sent out the frame uncompressed
 
     // frame is not compressed 
	 vidH.compressed = 0;
    
	 // set length parameters of video header for an uncompressed frame
	 vidH.len_total = (vidH.widthframe*vidH.heightframe*vidH.bpp/8)+sizeof(VIDHDR);
     vidH.len_data = (vidH.widthframe*vidH.heightframe*vidH.bpp/8);
	 vidH.len_fmthdr = 0;

     // calculate writepos for frame bits inside m_pAktFrameData
	 writepos = (char *) m_pAktFrameData;
	 writepos += sizeof(VIDHDR);
	  
     // copy the raw bits in it
	 memman.memcpysw( writepos, (char *) imagedata, (vidH.widthframe*vidH.heightframe*vidH.bpp/8) );

	 // copy the video header on top of the raw bits
	 memman.memcpysw( m_pAktFrameData, (char *) &vidH, sizeof(VIDHDR));

	}
	 else // compression ratio was sufficent
	{
		// a compressed frame
		vidH.compressed = 1;
    	
		// copy the video header in the usual location
		memman.memcpysw( (char *) m_pAktFrameData, (char *) &vidH, sizeof(VIDHDR));

        // put the output format right after the video header and before the video data 
		// (compressed bits) 
		writepos = (char *) m_pAktFrameData;
		writepos += sizeof(VIDHDR);
		memman.memcpysw( (char *) writepos, (char *) m_pOutputFmt, vidH.len_fmthdr);
	}

    

    // initialize actual frame length variable
	m_iAktFrameLength = vidH.len_total;

    // do fourier analysis on the actual raw frame
	m_pFourierStat = new CFourierStat((unsigned char *)imagedata, 5, 1, vidH.widthframe, vidH.heightframe);
	if (m_pFourierStat != NULL)
	{
	 m_pFourierStat->START();

     // tell EQP function that we are updating fourier variables
	 m_bFourierUpdate = TRUE; 	

     // update fourier variables (spot center and size)
     m_fXMean = (float) m_pFourierStat->XM();
     m_fYMean = (float) m_pFourierStat->YM();
     m_fXRms = (float) m_pFourierStat->X_RMS();
     m_fYRms = (float) m_pFourierStat->Y_RMS();

     // we are not updating the fourier variables any more
	 m_bFourierUpdate = FALSE;

     // delete fourierstat instance
     delete m_pFourierStat;
    }

	// free no longer needed memory
    if (tmpbuf != NULL) memman.sw_free( (void *) tmpbuf );
    memman.sw_free( (void *) frame );

    m_CSockEncap.Send( m_pAktFrameData, m_iAktFrameLength );

	//m_CSockEncap2.Send( m_pAktFrameData, m_iAktFrameLength );
	if (m_bLossyEnabled == TRUE) m_CSockEncap2.Send( m_pJPEGFrameData, m_iJPEGFrameLength );

/*
Updating calculated values 
*/

	m_tLastFrameAcquiredAt = vidH.timestamp;

    // put the framerate onto dialog
    CString msgf;
	msgf.Format("%f", vidH.framerate );
	m_CEditFramerate.SetWindowText((LPCTSTR) msgf);

	char heartbeat[4][3]={"|","\\","--","/"};

    // put heartbeat onto dialog
	msgf.Format("%s", heartbeat[vidH.frameno%4] );
	m_CEditHeartbeat.SetWindowText((LPCTSTR) msgf);

    // put spot center and size onto hidden control 
	CString msg8;
	msg8.Format("xm=%f ym=%f xrms=%f yrms=%f", m_fXMean, m_fYMean, m_fXRms, m_fYRms);
	m_CEditStatus.SetWindowText((LPCTSTR) msg8 );

    // put total length of actual frame onto hidden control on the main dialog
	//CString msg7;
	//msg7.Format("%d", m_iAktFrameLength);
	//m_CEditTmp.SetWindowText((LPCTSTR) msg7);

    //char *timeline;
	//char buffer[1000];
    //timeline = ctime( & (vidH.timestamp.time ) );
    //sprintf( buffer, "%.19s.%hu %s", timeline, vidH.timestamp.millitm, &timeline[20] );
	//CString msg;
	//msg.Format("frm: cport=%d, fno=%d, (w,h)=(%d/%d), data=%xh len_frame=%d, tstamp=%s", vidH.cameraport, vidH.frameno, vidH.widthframe, vidH.heightframe, imagedata, vidH.len_data, buffer);
	//m_CEditStatus.SetWindowText( (LPCTSTR) msg );
/*
Updating end
*/
/*
   if (first == -1)
   {
    first = 1;
	num++;
   
    FILE *fp;
    fp = fopen("c:\\new_grabsrv_framerate.txt", "at");
	 
    ::_ftime( &starttime );
    char *timeline = ctime( &starttime.time );
    fprintf(fp,"Test run starts on %d ms, rest of the time is %s\n", starttime.millitm, timeline);
    fprintf(fp,"one entry every 21600 frames (6 hours at 1 hz)\n");
    fclose( fp ); 
   }
   else if (first == 1)
   {
    num++;
	if (num == 21600) // 21600
	{ 
      first = 2;
	  FILE *fp1;
	  fp1 = fopen("c:\\new_grabsrv_framerate.txt", "at");

      _timeb actualtime;

	  ::_ftime( &actualtime );
	  char *timeline1 = ctime( &actualtime.time );

      double passedmilliseconds, framerate;

  	  passedmilliseconds = difftime(actualtime.time, starttime.time) * 1000.0;

	  passedmilliseconds -= ((double)starttime.millitm);
	  passedmilliseconds += ((double)actualtime.millitm);
	
          // calculate the frame rate (average calculation) 
      framerate = 1000.0 / ( passedmilliseconds / (num-1)*1.0);

      fprintf(fp1, "Framerate: %f, frames=%d, milliseconds=%d, timestr=%s", framerate, (num-1), actualtime.millitm, timeline1);
	  fprintf(fp1, "Passed milliseconds=%f\n", passedmilliseconds);
	 
	  fclose( fp1 ); 
	}//if num==
   }//elseif first==1
*/
/*
	if (first == -1 || first == 1)
	{
	 if (first == -1)
	 { 
	  first=1;
	  FILE *fp;
	  fp = fopen("c:\\grabsrv_framerate.txt", "at");
	 
	  _timeb firsttime;

	  ::_ftime( &firsttime );
	  char *timeline = ctime( &firsttime.time );
	  fprintf(fp,"Test run starts on %s\n", timeline);
	  fprintf(fp,"one entry every 150 frames (30 seconds at 5 hz)\n");
	  fclose( fp ); 
	 }
	  else 
	 {
	  num++;
	  first=2;
	 }
	}
	else
	{
	 num++;
	 if (num%150 == 0)
	 {
      FILE *fp1;
	  fp1 = fopen("c:\\grabsrv_framerate.txt", "at");

      _timeb actualtime;

	  ::_ftime( &actualtime );
	  char *timeline1 = ctime( &actualtime.time );

      double passedmilliseconds, framerate;

  	  passedmilliseconds = difftime(actualtime.time, starttime.time) * 1000.0;

	  passedmilliseconds -= ((double)starttime.millitm);
	  passedmilliseconds += ((double)actualtime.millitm);
	
          // calculate the frame rate (average calculation) 
      framerate = 1000.0 / ( passedmilliseconds / 150);

      fprintf(fp1, "%f,%s", framerate, timeline1);
	 
	  fclose( fp1 ); 
	  first = 1;
	  memcpy((void *) &starttime, (const void *) &vidH.timestamp, sizeof(_timeb));
	 }
	}
*/
    // schedule the tine video frame property
    //ScheduleProperty("GRFEQM", "FRAME.GET");

	// notify function is not running any more
	m_bNotifyRunning = FALSE;

}

BOOL CMainDlg::CheckEffectiveBits(void *imagedata, UINT bpp, UINT bpp_eff, UINT numpixels)
{
	unsigned int effmaxval;

	if (bpp == 8)
	{
		unsigned short effmaxval_uchar;

		if (bpp_eff > bpp) bpp_eff = bpp;

		effmaxval = 1<<bpp_eff;
		effmaxval_uchar = (unsigned char) (effmaxval - 1);

		unsigned char *pixel = (unsigned char *) imagedata;

		for (UINT i=0;i<numpixels;i++)
		{
			if (*pixel++ > effmaxval_uchar) return FALSE;
		}

	}
	else if (bpp == 16)
	{
		unsigned short effmaxval_ushort;
			
		if (bpp_eff > bpp) bpp_eff = bpp;

		effmaxval = 1<<bpp_eff;
		effmaxval_ushort = (unsigned short) (effmaxval - 1);

		unsigned short *pixel = (unsigned short *) imagedata;

		for (UINT i=0;i<numpixels;i++)
		{
			if (*pixel++ > effmaxval_ushort) return FALSE;
		}
	}
	else if (bpp == 32)
	{
		unsigned int effmaxval_uint;
			
		if (bpp_eff > bpp) bpp_eff = bpp;

		effmaxval = 1<<bpp_eff;
		effmaxval_uint = (unsigned int) (effmaxval - 1);

		unsigned int *pixel = (unsigned int *) imagedata;

		for (UINT i=0;i<numpixels;i++)
		{
			if (*pixel++ > effmaxval_uint) return FALSE;
		}
	}
	else return FALSE;

	return TRUE;
}



///////////////////////////////////////////////////////////////////////////////
//
// This function is called via the 'Config' button on the main dialog. It shows
// up the configuration dialog, and initiates a reinitialization of all subsystems 
// after the dialog has been closed using 'OK'.
//
void CMainDlg::OnButtonConfig() 
{ 
  int boardno;
  int sysno;
  int port,port2;
  int maxclients,maxclients2;
  int enabled2;
  CString msg3;
  CString l_servername;
  BOOL initFailed = FALSE;

  short nref=-1, pref=-1;

  // obtain nref and pref from grabbing class
  if (m_pGrab != NULL)
  {
   m_pGrab->getNRef(  nref );
   m_pGrab->getPRef(  pref );
  }

  // construct configuration dialog
  CConfigDlg dlg( (int) nref, (int) pref, this );

  // set ini file reference
  dlg.setConfiguration( m_pIniFile );

  int ret = -1;
  ret = dlg.DoModal();

  CString tine_frame_eqp = m_pIniFile->GetValue("DEFAULT", "TINEFRAMEEQPNAME", "");

  // Handle the return value from DoModal
  switch ( ret )
  {
   case -1: 
      AfxMessageBox("Configdialog could not be created!");
      break;
   case IDOK:
       
       // okay, the user has pressed 'OK' on the configuration
	   // dialog, so he might have changed some values. We have
	   // to reinitialize every subsystem. 

       // save the new config to file 
       if (m_pIniFile != NULL) 
	   {
		   BOOL ret4 = m_pIniFile->WriteFile();
		   if (ret4 == FALSE) PrintServerMessage("Error on saving settings to config file in OnButtonConfig.");
	   }
       
	   // deinitialize everything
	   DeinitializeNetwork(); // shut down network (sockets)
	   DeinitializeTine(); // shut down TINE server
	   DeinitializeCompressionCodec(); // shut down compression codec
	   DeinitializeITEX(); // shut down ITEX grabber

       // restore default button state  
	   m_CButtonStartGrabbing.EnableWindow(TRUE);
       m_CButtonStopGrabbing.EnableWindow(FALSE);

       // get ITEX variables from configuration 
       boardno = m_pIniFile->GetValueInt("DEFAULT", "BOARDNUMBER", 0);
       sysno = m_pIniFile->GetValueInt("DEFAULT", "SYSTEMNUMBER", 0);
	   
       // initialize grabbing subsystem and print error
       // if it could not be initialized
   	   
	   m_pGrab = NULL;
	   ret = InitializeITEXGrabber();
       if (ret == TRUE) 
	     PrintServerMessage("Successful initialized ITEX grabber (PCVision card).");
       else
	   {
        AfxMessageBox("Could not initialize ITEX grabber (PCVision card) !", MB_ICONEXCLAMATION | MB_OK );
	    initFailed = TRUE;
	   }

       // initialize compression codec and print error
       // if it could not be initialized
       m_pCodec = NULL;
       ret = InitializeCompressionCodec(m_iGrabWidth, m_iGrabHeight, m_iGrabBpp);
       if (ret == TRUE) 
		PrintServerMessage("Successful initialized compression codec.");
	   else
	   {
		AfxMessageBox("Could not initialize compression codec.", MB_ICONEXCLAMATION | MB_OK );
		initFailed = TRUE;
	   }

       // initialize TINE subsystem and print error
       // if it could not be initialized
	   ret = InitializeTine();
       if (ret == TRUE) 
	   {
		   CString tmp1;
		   tmp1.Format("Successful initialized TINE. %s", l_servername);
	       PrintServerMessage(tmp1);
	   }
       else
	   {
          AfxMessageBox("Could not initialize TINE !", MB_ICONEXCLAMATION | MB_OK );
	      initFailed = TRUE;
	   }

       // get network variables
       port = m_pIniFile->GetValueInt( "DEFAULT", "LISTENPORTNUMBER", 31777);
	   maxclients = m_pIniFile->GetValueInt( "DEFAULT", "MAXCLIENTS", 255);

       port2 = m_pIniFile->GetValueInt( "DEFAULT", "LISTENPORTNUMBERLOSSY", 31778);
	   maxclients2 = m_pIniFile->GetValueInt( "DEFAULT", "MAXCLIENTSLOSSY", 255);
       enabled2 = m_pIniFile->GetValueInt( "DEFAULT", "LOSSYENABLED", 1);

	   if (enabled2 == 1) m_bLossyEnabled = TRUE; else m_bLossyEnabled = FALSE;

	   // initialize network subsystem and print error
       // if it could not be initialized
       ret = InitializeNetwork(port, maxclients, enabled2, port2, maxclients2, tine_frame_eqp, (m_iGrabWidth*m_iGrabHeight*m_iGrabBpp/8)); 
	   if (ret == TRUE)
	     PrintServerMessage("Successful initialized Sockets.");
        else
		{
          AfxMessageBox("Could not initialize Sockets !", MB_ICONEXCLAMATION | MB_OK );
		  initFailed = TRUE;
		}

       if (initFailed == TRUE)
	   {
			m_bGrabbingCanBeStarted = FALSE;
			m_CButtonStartGrabbing.EnableWindow(FALSE);
			m_CButtonStopGrabbing.EnableWindow(FALSE);
	   }
	    else
   	   {
			m_bGrabbingCanBeStarted = TRUE;
			m_CButtonStartGrabbing.EnableWindow(TRUE);
			m_CButtonStopGrabbing.EnableWindow(FALSE);
       }

       break;
   case IDCANCEL:
      // do not reinitialize system
      break;

   default:
      // Do nothing
      break;
  }
}

///////////////////////////////////////////////////////////////////////
//
// In this function the grabbing is started up. It is called if the user
// presses the button 'Start Grabbing'.
//
void CMainDlg::OnButtonStartGrabbing() 
{
	if (m_pGrab != NULL) // grab class instantiated ? 
	{
		BOOL ret = m_pGrab->StartGrab(); // start up grabbing
		if (ret == TRUE) // evrything went fine ? 
		{
			// print out success message
			PrintServerMessage("Grabbing started."); 
			m_bGrabbingStarted = TRUE;
			
			// initialize frame number to zero (first frame)
			m_iFrameNo = 0;
			
			// set button state accordingly
			// ( disable 'Start Grabbing' button,
			//   enable  'Stop Grabbing' button,
			//   disable 'Config' button) 
			m_CButtonStartGrabbing.EnableWindow(FALSE);
			m_CButtonStopGrabbing.EnableWindow(TRUE);
            m_CButtonConfig.EnableWindow(FALSE);

		} 
		else PrintServerMessage("Error while starting up grabbing."); // print error msg
    }
}

///////////////////////////////////////////////////////////////////////
//
// In this function the grabbing is stopped. It is called if the user
// presses the button 'Stop Grabbing'.
//
void CMainDlg::OnButtonStopGrabbing() 
{
    // disable close button
	m_ButtonClose.EnableWindow(FALSE);
	if (m_pGrab != NULL) // grab class is instantiated ? 
	{
		BOOL ret = m_pGrab->StopGrab(); // stop grabbing
		if (ret == TRUE) // success ? 
		{
			// print success message
			PrintServerMessage("Grabbing stopped."); 
			m_bGrabbingStarted = FALSE;
    		
			// set button state accordingly
			m_CButtonStartGrabbing.EnableWindow(TRUE);
			m_CButtonStopGrabbing.EnableWindow(FALSE);
		}
		else PrintServerMessage("Error while stopping grabbing.");// print error msg
    }
	
	// even if grabbing could not be stopped successfully, enable
	// close and config buttons
	m_ButtonClose.EnableWindow(TRUE);
	m_CButtonConfig.EnableWindow(TRUE);
}

///////////////////////////////////////////////////////////////////////////////////////
//
// This function initializes the ITEX subsystem (the grab class). After the system is 
// properly initialized, the camera port is changed. The function returns TRUE if 
// everything went fine, FALSE otherwise. The parameters are the two ITEX variables
// system number and board number. Normally both parameters should be set to zero.
//
BOOL CMainDlg::InitializeITEXGrabber()
{
 BOOL ret;
 int localcamport = m_iCurCamPort;

 if ((localcamport<0) || (localcamport>3)) localcamport = 3;

 // get ITEX variables from configuration 
 int boardno = m_pIniFile->GetValueInt("DEFAULT", "BOARDNUMBER", 0);
 int system  = m_pIniFile->GetValueInt("DEFAULT", "SYSTEMNUMBER", 0);

 m_bGrabbingStarted = FALSE;
 m_iUpdateSuccessful = 1; // no update happened, i.e. Update successful

 // create grab queue, if it could not be created then return failure
 m_pGrabQueue = new CQueue();
 if (m_pGrabQueue == NULL) return( FALSE );
 
 // instantiate grab class
 m_pGrab = new CGrab();
 if (m_pGrab == NULL)
 {
  return( FALSE );
 }

 BOOL exttrig=TRUE;
 BOOL trigmod5=FALSE;

 CString exttrigenabled = m_pIniFile->GetValue( "DEFAULT", "ExternalTrigger", "TRUE");
 CString exttrigmod5 = m_pIniFile->GetValue( "DEFAULT", "TriggerMod5", "FALSE");
 if (exttrigenabled == "FALSE") { exttrig = FALSE; m_iCurCamTrigger=FALSE; } else { m_iCurCamTrigger = TRUE; }
 if (exttrigmod5 == "TRUE") { trigmod5 = TRUE; m_iCurCamTrigMod5 = TRUE; } else { m_iCurCamTrigMod5 = FALSE; }

 short nref = (short) m_pIniFile->GetValueInt( "CameraSettings", "NegativeReference", 234);
 short pref = (short) m_pIniFile->GetValueInt( "CameraSettings", "PositiveReference", 782);

 // SW! disabled, takes too much time (around 12 seconds with this workaround)
 // SW! June 28, 2006
 // SW! but works no matter how much the framegrabber card was screwed up
 //
 //BOOL exttrigswap =  exttrig;
 //if (exttrigswap == FALSE) exttrigswap = TRUE; else exttrigswap = FALSE;

 //ret = m_pGrab->Init(system, boardno, exttrigswap, trigmod5, m_pGrabQueue, nref, pref);
 //if (ret == TRUE) 
 //{
 //	 m_pGrab->setCamera( localcamport ); // muss exakt der camport sein, der dann auch benutzt wird !!!
 //	 m_pGrab->StartStopGrabWorkaround();
 //	 m_pGrab->Done(); 
 //}
 //else PrintServerMessage("Startup after kill workaround m1 failed. First grabbing may not start !");
 

 // SW! June 14, 2006 workaround start 
 ret = m_pGrab->Init(system, boardno, exttrig, trigmod5, m_pGrabQueue, nref, pref);
 if (ret == TRUE) 
 {
	 m_pGrab->setCamera( localcamport ); // muss exakt der camport sein, der dann auch benutzt wird !!!
	 m_pGrab->Done(); 
 }
 else PrintServerMessage("Startup after kill workaround failed. First grabbing may not start !");

 // initialize grabbing (ITEX) subsystem
 // SW! June 14, 2006 workaround end
 ret = m_pGrab->Init(system, boardno, exttrig, trigmod5, m_pGrabQueue, nref, pref);

 // switch to actually selected camera port
 // if initialization was successful
 if (ret == TRUE) 
 {
   m_pGrab->setCamera( localcamport );
 
   // initialize grab width and height
   m_iGrabWidth = m_pGrab->getFrameWidth();
   m_iGrabHeight = m_pGrab->getFrameHeight();
   m_iGrabBpp = m_pGrab->getFrameBpp();
 }

 return( ret );
}

///////////////////////////////////////////////////////////////////////////////////////
//
// This function is needed for proper closing the application if the user presses the 
// 'X' on the title bar or the hotkey 'ALT-F4'. The application is not just closed, but
// safely shut down by calling the deinitalization routine 'OnButtonClose'.
void CMainDlg::OnCancel()
{
 OnButtonClose();
}

///////////////////////////////////////////////////////////////////////////////////////
//
// This function is needed for proper closing the application if the user presses the 
// 'X' on the title bar or the hotkey 'ALT-F4'. The application is not just closed, but
// safely shut down by calling the deinitalization routine 'OnButtonClose'.
void CMainDlg::OnOK()
{
 OnButtonClose();
}

///////////////////////////////////////////////////////////////////////////////////////
//
// This is the deinitialization routine of the application. It is called when the user
// presses the 'Close' button or closes the application through the 'X' or 'ALT-F4'.
//
void CMainDlg::OnButtonClose() 
{
  // save the configuration to file and
  // delete the config class instance
  DeinitializeIniFile();

  // deinitialize the subsystems
  DeinitializeNetwork();
  DeinitializeTine();
  DeinitializeCompressionCodec();
  DeinitializeITEX();

  // kill the set environment variable timer
  if (m_nTimer != 0) KillTimer( m_nTimer );

  m_bDeadManFlipFlopRunning = FALSE; // should stop 

  while( m_bDeadManFlipFlopIsActive == TRUE )
  {
   ::Sleep(100);
  }

  // call proper base class method to shut down main dialog and the application
  CDialog::OnOK();
}

///////////////////////////////////////////////////////////////////////////////////////
//
// This function initializes the compression codec class CCompression and some data 
// structures that are needed in addition to the CCompression class. This piece of 
// code initializes the HuffYUV codec by Ben Rudiak-Gold. For proper grabbing and 
// displaying the video on the client, a special version of the codec is needed.
// It is the HuffYUV codec version 1.2.3)
BOOL CMainDlg::InitializeCompressionCodec( int width, int height, int bpp)
{
    BOOL ret;
	
	// build up input format for codec, please note
	// that we are compressing grayscale (8bpp) frames,
	// but the codec only knows 24bit color images.
	// so we divide the width by 3 so that the proper
	// size is maintained
	//

	m_pJPEGCompression = new CJPEGCompression();
	if (m_pJPEGCompression == NULL)
	{
		return FALSE;
	}
	m_pJPEGCompression->Init( width, height );
	m_pJPEGCompression->SetQuality( m_iJPEGQuality );

	m_iJPEGMaxFrameLength = m_pJPEGCompression->GetMaxCompressedSize();
	m_pJPEGFrameData = (char *) memman.sw_malloc( m_iJPEGMaxFrameLength );
	if (m_pJPEGFrameData == NULL)
	{
        m_pJPEGCompression->Done();
		delete m_pJPEGCompression;
		m_pJPEGCompression = NULL;
		return FALSE;
	}

    int codecwidth = width;
	int codecheight = height;
    
	m_InputFmt.biSize = sizeof(BITMAPINFOHEADER);
    m_InputFmt.biBitCount = 24;
    m_InputFmt.biClrImportant = 0;
    m_InputFmt.biClrUsed = 0;
    m_InputFmt.biCompression = BI_RGB;
    m_InputFmt.biHeight = codecheight;
    m_InputFmt.biWidth = codecwidth;
    m_InputFmt.biPlanes = 1;
    m_InputFmt.biSizeImage = codecwidth*codecheight*bpp/8; // *8/8 (8bpp data);
    m_InputFmt.biXPelsPerMeter = 0;
    m_InputFmt.biYPelsPerMeter = 0;

    // instantiate CCompression class
	m_pCodec = new CCompression();
	if (m_pCodec == NULL)
	{
        memman.sw_free( (void *) m_pJPEGFrameData );
		m_pJPEGFrameData = NULL;
        m_pJPEGCompression->Done();
		delete m_pJPEGCompression;
		m_pJPEGCompression = NULL;
		myErrorHandler(-1, "CMainDlg::InitializeCompressionCodec : Error instantiating CCompression class.");
		return FALSE;
	}

    // initialize HuffYUV codec
	ret = m_pCodec->Init(MAKEFOURCC('H','F','Y','U'), &m_InputFmt );
	if (ret != TRUE) 
	{
     memman.sw_free( (void *) m_pJPEGFrameData );
  	 m_pJPEGFrameData = NULL;
     m_pJPEGCompression->Done();
	 delete m_pJPEGCompression;
	 m_pJPEGCompression = NULL;

     delete m_pCodec;
	 m_pCodec = NULL;
	 return FALSE;
	}

    // obtain the length of the output format
	int fmtsize;
	ret = m_pCodec->GetOutputFormatLength( &fmtsize );
    if (ret != TRUE) 
	{
      memman.sw_free( (void *) m_pJPEGFrameData );
      m_pJPEGFrameData = NULL;
      m_pJPEGCompression->Done();
	  delete m_pJPEGCompression;
	  m_pJPEGCompression = NULL;

	  m_pCodec->Done();
	  delete m_pCodec;
	  m_pCodec = NULL;
	  return FALSE;
	}

    // allocate memory for the output format
	m_pOutputFmt = (LPBITMAPINFOHEADER) memman.sw_malloc(fmtsize);
    if (m_pOutputFmt == NULL)
	{
        memman.sw_free( (void *) m_pJPEGFrameData );
		m_pJPEGFrameData = NULL;
        m_pJPEGCompression->Done();
		delete m_pJPEGCompression;
		m_pJPEGCompression = NULL;

		myErrorHandler(-1, "CMainDlg::InitializeCompressionCodec : Could not allocate memory needed for output format.");
        m_pCodec->Done();
	    delete m_pCodec;
	    m_pCodec = NULL;
		return FALSE;
	}
  
    // put the right size into the newly allocated structure 
    // and obtain the output format from the codec
	m_pOutputFmt->biSize = fmtsize;
	ret = m_pCodec->GetOutputFormat( m_pOutputFmt );
	if (ret == FALSE) 
	{
     memman.sw_free( (void *) m_pJPEGFrameData );
	 m_pJPEGFrameData = NULL;
     m_pJPEGCompression->Done();
	 delete m_pJPEGCompression;
	 m_pJPEGCompression = NULL;
   	 memman.sw_free( (void *) m_pOutputFmt );
	 m_pOutputFmt = NULL;
	 m_pCodec->Done();
	 delete m_pCodec;
	 m_pCodec = NULL;
	 return FALSE;
	}

    // get the maximum size of a compressed frame from the codec
	int framesize;
	BOOL retx = m_pCodec->GetMaxCompressedSize( &framesize );
    if (retx == FALSE)
	{ 
     memman.sw_free( (void *) m_pJPEGFrameData );
	 m_pJPEGFrameData = NULL;
     m_pJPEGCompression->Done();
	 delete m_pJPEGCompression;
	 m_pJPEGCompression = NULL;

  	 myErrorHandler(-1, "CMainDlg::InitializeCompressionCodec: Could not get max length of compressed picture.");
     memman.sw_free( (void *) m_pOutputFmt );
	 m_pOutputFmt = NULL;
	 m_pCodec->Done();
	 delete m_pCodec;
	 m_pCodec = NULL;
	 return FALSE;
	}

    // allocate memory to store a single compressed frame before it gets send out
    m_pAktFrameData = (char *) memman.sw_malloc( framesize+sizeof(VIDHDR)+fmtsize );
	if (m_pAktFrameData == NULL)
	{
     memman.sw_free( (void *) m_pJPEGFrameData );
	 m_pJPEGFrameData = NULL;
     m_pJPEGCompression->Done();
	 delete m_pJPEGCompression;
	 m_pJPEGCompression = NULL;
     
	 myErrorHandler(-1, "CMainDlg::InitializeCompressionCodec: Could not allocate buffer for compressed frame.");
     memman.sw_free( (void *) m_pOutputFmt );
	 m_pOutputFmt = NULL;
	 m_pCodec->Done();
	 delete m_pCodec;
	 m_pCodec = NULL;
     return FALSE; 
	}

	return TRUE; // success
}

///////////////////////////////////////////////////////////////////////////////////////
//
// This function deinitializes the ITEX subsystem. If the grabbing is still active, we
// shut it down. After this, the grabbing class is deinitialized and freed. This function
// returns always TRUE.
//
BOOL CMainDlg::DeinitializeITEX()
{
  if (m_pGrab != NULL) // grab class instantiated ? 
  {
	  if (m_pGrab->IsGrabbing() == TRUE) // are we grabbing ? 
	  {
          // print message
		  PrintServerMessage("Shutting down grabbing.");
		  // shut it down
		  m_pGrab->StopGrab();
	  }

      // deinitialize grabbing class 
	  PrintServerMessage("Deinitializing ITEX grabber...");
	  m_pGrab->Done();

      // delete grabbing instance from memory
	  delete m_pGrab;
      m_pGrab = NULL;
  }

  // clean up grab queue
  if (m_pGrabQueue != NULL)
  {
   delete m_pGrabQueue;
   m_pGrabQueue = NULL;
  }

  return TRUE; // success
}


///////////////////////////////////////////////////////////////////////////////////////
//
// This function deinitializes the compression codec class CCompression and some data 
// structures that were created together with the CCompression class. This function 
// returns always TRUE.
//
BOOL CMainDlg::DeinitializeCompressionCodec()
{
 BOOL ret;

 PrintServerMessage("Deinitializing compression codec...");

 if (m_pCodec != NULL) // codec class is instantiated ?
 {
	 ret = m_pCodec->Done(); // deinitialize it
	 delete m_pCodec; // free codec instance
	 m_pCodec = NULL;
 }

 if (m_pOutputFmt != NULL) // output format allocated ? 
 {
	 memman.sw_free( (void *) m_pOutputFmt ); // deallocate it
	 m_pOutputFmt = NULL;
 }

 if (m_pAktFrameData != NULL) // akt frame data allocated ? 
 {
	 memman.sw_free( (void *) m_pAktFrameData ); // free it
	 m_pAktFrameData = NULL;
 }

 if (m_pJPEGCompression != NULL)
 {
     m_pJPEGCompression->Done();
	 delete m_pJPEGCompression;
	 m_pJPEGCompression = NULL;
 }

 if (m_pJPEGFrameData != NULL)
 {
	 memman.sw_free( (void *) m_pJPEGFrameData);
     m_pJPEGFrameData = NULL;
 }

 return TRUE; // success
}

/////////////////////////////////////////////////////////////////////////////////////
// 
// This function is needed to output errors that happen while executing the program.
// A error message is constructed out of the parameters and displayed using a message 
// box.
// 
// Parameter:
//   errornum    :  additional error number, is not really used at the moment
//   format, ... :  same like printf()
// 
// Return value:
//   always 1
//
// Remarks:
//   Please not that the string you construct should not be larger than 511 characters
//   (512 including the '0' at the end). Otherwise the string will be truncated. 
//
int CMainDlg::myErrorHandler( int errornum, const char *format, ... )
{
 char m_msg[512];
	
 va_list args;
 va_start(args, format);
 _vsnprintf(m_msg, 511, format, args);
 va_end(args);
 
 m_iLastError = errornum;
 AfxMessageBox( m_msg, MB_ICONEXCLAMATION | MB_OK );

 return 1;
}

/////////////////////////////////////////////////////////////////////////////////////
// 
// This function initializes the TINE subsystem of the server. The system is needed for
// remotely accessing some functions on the server, e.g. switching of the camera port.
// The TINE server name in the name service is always the computer name in upper case.
// That makes it easy for the client to access a specific server.
//
BOOL CMainDlg::InitializeTine()
{
    static int register_1 = 1;
	static int register_2 = 1;
	int portnumber;
	CString servername;
	CString context;

    servername = m_pIniFile->GetValue("DEFAULT", "TINECONTROLEQPNAME", "");
	if (servername == "") return FALSE;

    portnumber = m_pIniFile->GetValueInt("DEFAULT", "TINEPORTNUMBER", 11);

	context = m_pIniFile->GetValue("DEFAULT", "TINECONTEXT", "PITZ");

    // build up title bar string of the grabber server
    CString title = CString("GrabServer2 on ") + servername;
	PrintServerMessage( title );
	
    if (register_1 == 1) // register the FEC name only _once_ after starting the program
	{
  	 // build up description string
	 CString descStr = CString("Grabber server control of ");
	 descStr += servername;
    
	 // register fec name (needed for name service to access the application)
	 short ret = RegisterFecNameEx( (char *) (LPCTSTR) servername, (char *) (LPCTSTR) descStr, (char *) "PITZ", (char *) "none", (char *) "sweisse@ifh.de", (short) portnumber, (char *) (LPCTSTR) context);

	 if (ret != 0) // error while RegisterFecName
	 {
       CString msg;
   	   msg.Format("Tine: Error in RegisterFecName: Status=%d", ret);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
	 }

	 register_1 = 0; // do not execute this if-block any more
	}

    // set the export name of the tine server
	m_CTineServer.SetExportName( (LPCTSTR) servername );

    // minimum pollin rate of clients is 50 ms
	SetMinimumPollingRate(50);
	SetBurstLimit(500); // 500
	SetCycleDelay(0); // 0
	SetWorkAreaSize( 1800000 );
 
    // enable the TINE serve
 	m_CTineServer.SetEnabled(TRUE);
    
	// get status whether the server was started up successfully
	short retval = m_CTineServer.GetEqpStatus();
 	if (retval != 0)
 	{
      // some error
      CString msg;
   	  msg.Format("InitTine: EqpStatus=%d", retval);
      AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	  return FALSE;
 	}

    // register module (device) on the server
    m_CTineServer.EqpRegisterModule("GRABSRV",0);

    // from now on, the different properties that the server offers the clients
	// are registered.

    if (register_2 == 1)
	{
     // register property that allows clients to read the description string of the camera port 0
 	 retval = m_CTineServer.EqpRegisterPropertyEx("C_CAMNAME", 32, CF_TEXT, "", 1, CF_NAME48, "", CA_READ | CA_WRITE, "Grabber: read camera name string");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

	 // register property that allows clients to read the description string of the camera port 0
 	 retval = m_CTineServer.EqpRegisterPropertyEx("S_Servername", 32, CF_TEXT, "", 1, CF_NAME48, "", CA_READ, "Grabber: read server name");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property that allows clients to read the description string of the camera port 0
 	 retval = m_CTineServer.EqpRegisterPropertyEx("C_ActiveSince", 32, CF_TEXT, "", 1, CF_NAME48, "", CA_READ, "Grabber: camera active since");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property that allows clients to read the description string of the camera port 0
 	 retval = m_CTineServer.EqpRegisterPropertyEx("S_StartTime", 32, CF_TEXT, "", 1, CF_NAME48, "", CA_READ, "Grabber: server startup time");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property to read/write the camera port
	 // if you read, you get the actual camera port back
	 // if you write, the camera port you submitted is selected 
	 // and you can read the result (you get the actual camera port after selection back)
 	 retval = m_CTineServer.EqpRegisterPropertyEx("C_LOCALCAMPORT", 1, CF_UINT32, "", 1, CF_UINT32, "", CA_READ | CA_WRITE, "Grabber: change local camera port");
 	 if (retval < 0)
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property to read/write the camera description strings
	 // This is more like a RPC call, e.g. CString get_grabber_camera_string( char camera port );
	 //
	 // so you write a byte value of 0..3 to the server and you will get the appropriate camera
	 // string back
 	 retval = m_CTineServer.EqpRegisterPropertyEx("C_CAMID", 10, CF_TEXT, "", 1, CF_NAME48, "", CA_READ | CA_WRITE, "Grabber: r/w camera id");
 	 if (retval < 0)
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property to read the actual spot data 
	 // you get a structure back, which contains one int and three floats describing 
	 // the spot center and size
 	 retval = m_CTineServer.EqpRegisterPropertyEx("S_SPOTDATA", 1, CF_BYTE, "", 1, CF_IFFF, "", CA_READ | CA_WRITE, "Grabber: Get spot size and position");
 	 if (retval < 0)
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property that allows clients to read the scale of the camera port 0
 	 retval = m_CTineServer.EqpRegisterPropertyEx("C_SCALE", 1, CF_DOUBLE, "", 1, CF_DOUBLE, "", CA_READ | CA_WRITE, "Grabber: r/w scale factor of camera");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

	 // register property that allows clients to read the scale of the camera port 0
 	 retval = m_CTineServer.EqpRegisterPropertyEx("C_DYNAMICSCALE", 1, CF_DOUBLE, "", 1, CF_DOUBLE, "", CA_READ | CA_WRITE, "Grabber: set dynamic scale factor");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property that allows clients to read the scale of the camera port 1
 	 retval = m_CTineServer.EqpRegisterPropertyEx("C_NREF", 1, CF_UINT32, "", 1, CF_UINT32, "", CA_READ | CA_WRITE, "Grabber: rw NREF ADC value");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property that allows clients to read the scale of the camera port 2
 	 retval = m_CTineServer.EqpRegisterPropertyEx("C_PREF", 1, CF_UINT32, "", 1, CF_UINT32, "", CA_READ | CA_WRITE, "Grabber: rw PREF ADC value");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property that allows clients to read the scale of the camera port 3
 	 retval = m_CTineServer.EqpRegisterPropertyEx("C_ORIENTATION", 20, CF_TEXT, "", 1, CF_NAME48, "", CA_READ | CA_WRITE, "Grabber: rw rotation setting");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property that allows clients to read the width of the video frame of camera port 0
 	 retval = m_CTineServer.EqpRegisterPropertyEx("C_WIDTH", 1, CF_UINT32, "", 1, CF_UINT32, "", CA_READ | CA_WRITE, "Grabber: rw width of video frame");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property that allows clients to read the width of the video frame of camera port 1
 	 retval = m_CTineServer.EqpRegisterPropertyEx("C_HEIGHT", 1, CF_UINT32, "", 1, CF_UINT32, "", CA_READ | CA_WRITE, "Grabber: rw height of video frame");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }


     // register property that allows clients to read the width of the video frame of camera port 2
 	 retval = m_CTineServer.EqpRegisterPropertyEx("C_EXTTRIG", 1, CF_UINT32, "", 1, CF_UINT32, "", CA_READ | CA_WRITE, "Grabber: rw external trigger on/off [1,0]");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property that allows clients to read the width of the video frame of camera port 3
 	 retval = m_CTineServer.EqpRegisterPropertyEx("C_TRIGMOD5", 1, CF_UINT32, "", 1, CF_UINT32, "", CA_READ | CA_WRITE, "Grabber: rw trigger mod 5 on/off [1,0]");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property that allows clients to read the height of the video frame of camera port 0
 	 retval = m_CTineServer.EqpRegisterPropertyEx("S_START", 1, CF_UINT32, "", 1, CF_UINT32, "", CA_WRITE, "Grabber: write 1 to activate server");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property that allows clients to read the height of the video frame of camera port 1
 	 retval = m_CTineServer.EqpRegisterPropertyEx("S_STOP", 1, CF_UINT32, "", 1, CF_UINT32, "", CA_WRITE, "Grabber: write 1 to deactivate server");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property that allows clients to read the height of the video frame of camera port 2
 	 retval = m_CTineServer.EqpRegisterPropertyEx("S_isStarted", 1, CF_UINT32, "", 1, CF_UINT32, "", CA_READ, "Grabber: server started [yes=1, no=0]");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property that allows clients to read the height of the video frame of camera port 3
 	 retval = m_CTineServer.EqpRegisterPropertyEx("S_isStopped", 1, CF_UINT32, "", 1, CF_UINT32, "", CA_READ, "Grabber: server stopped [yes=1, no=0]");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property that allows clients to check whether camera port 0 is enabled 
	 // (and thus, should be selectable on client side)
 	 retval = m_CTineServer.EqpRegisterPropertyEx("S_UPDATE", 1, CF_UINT32, "", 1, CF_UINT32, "", CA_WRITE, "Grabber: update to new settings");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property that allows clients to check whether camera port 1 is enabled 
	 // (and thus, should be selectable on client side)
 	 retval = m_CTineServer.EqpRegisterPropertyEx("S_isUpdated", 1, CF_UINT32, "", 1, CF_UINT32, "", CA_READ, "Grabber: read whether updating was successful");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property that allows clients to read the bits per pixel setting of the server
 	 retval = m_CTineServer.EqpRegisterPropertyEx("C_BPP", 1, CF_UINT32, "", 1, CF_UINT32, "", CA_READ | CA_WRITE, "Grabber: rw bits per pixel setting");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

     // register property that allows clients to read the bits per pixel setting of the server
 	 retval = m_CTineServer.EqpRegisterPropertyEx("S_availVideodata", 1, CF_UINT32, "", 1, CF_UINT32, "", CA_READ, "Grabber: are frames coming in from card ?");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }


     // register property that allows clients to read the compression id of the server
 	 retval = m_CTineServer.EqpRegisterPropertyEx("S_COMPRESSION", 1, CF_BYTE, "", 1, CF_UINT32, "", CA_READ, "Grabber: read compression id");
 	 if (retval < 0) 
 	 {
       // some error
       CString msg;
 	   msg.Format("EqpRegPropEx: Status=%d", retval);
       AfxMessageBox((LPCTSTR) msg, MB_OK | MB_ICONEXCLAMATION );
 	   return FALSE;
 	 }

	 register_2 = 0;
	}


 	return TRUE; // success
}

BEGIN_EVENTSINK_MAP(CMainDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CMainDlg)
	ON_EVENT(CMainDlg, IDC_SRVCTRL1, 1 /* EqpFcn */, OnEqpFcnSrvctrl1, VTS_BSTR VTS_BSTR VTS_I4 VTS_I4 VTS_I2)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()


BOOL CMainDlg::getInteger( unsigned int &outdata, unsigned int lowbound, unsigned int highbound )
{
	VARIANT iVar;
	
	VARIANT iVarTemp;
	BOOL ret = FALSE;

	// initialize camera port variant
	VariantInit( &iVar );
	V_VT( &iVar ) = VT_UI4;

	memcpy( &iVarTemp, &iVar, sizeof(VARIANT) );

	// receive camera port variant
	short rets = m_CTineServer.EqpRecvData( &iVar ); 

	if (rets == 0) // success ? 
	{
		if ((((unsigned)iVar.intVal) >= lowbound) && (((unsigned)iVar.intVal) <= highbound))
		{
			outdata = (unsigned int) iVar.intVal;
			ret = TRUE;
		}
	}

	VariantClear( &iVarTemp );

	return( ret );
}

BOOL CMainDlg::getDouble( double &outdata, double lowbound, double highbound )
{
	VARIANT dVar;
	VARIANT dVarTemp;
	BOOL ret = FALSE;

	// initialize camera port variant
	VariantInit( &dVar );
	V_VT( &dVar ) = VT_R8;

	memcpy( &dVarTemp, &dVar, sizeof(VARIANT) );

	// receive camera port variant
	short rets = m_CTineServer.EqpRecvData( &dVar ); 

	if (rets == 0) // success ? 
	{
		if ((dVar.dblVal >= lowbound) && (dVar.dblVal <= highbound))
		{
			outdata = dVar.dblVal;
			ret = TRUE;
		}
	}

	VariantClear( &dVarTemp );

	return( ret );
}


BOOL CMainDlg::getString( CString &outdata )
{
	int maxlength = 48;
	VARIANT sVar;
	VARIANT sVarTemp;
	char *m_pReturnedString;
	BOOL ret = FALSE;
	
    // variables needed to set up tine data transfer
	SAFEARRAY *psa;
	SAFEARRAYBOUND rgsabound[1];

	 // initialize a safe array width the maximum size of a 
	// video frame
	rgsabound[0].lLbound = 0;
	rgsabound[0].cElements = maxlength;

	if ((psa=SafeArrayCreate(VT_I1,1,rgsabound)) == NULL)
	{
		return FALSE;
	}

	// initialize tine data block variant
	VariantInit( &sVar );
	V_VT( &sVar ) = VT_I1 | VT_ARRAY;
	V_ARRAY( &sVar ) = psa;
	
	m_pReturnedString = (char *) psa->pvData;

	memcpy( &sVarTemp, &sVar, sizeof(VARIANT) );

    // send out the data
    short rets = m_CTineServer.EqpRecvData( &sVar );

    if (rets == 0) 
	{
		outdata = CString(m_pReturnedString);
		ret = TRUE;
	}

	VariantClear( &sVar );

	return( ret );
}



BOOL CMainDlg::sendString( CString str )
{
	CString localStr;
	VARIANT sVar;
	BOOL ret = FALSE;

	localStr = str;
	
	VariantInit( &sVar );
	V_VT( &sVar ) = VT_BSTR;
	V_BSTR( &sVar ) = localStr.AllocSysString();

    // send out the data
    short rets = m_CTineServer.EqpSendData( &sVar );

    if (rets == 0) ret = TRUE;

	VariantClear( &sVar );

	return( ret );
}


BOOL CMainDlg::sendInteger( unsigned int data )
{
	VARIANT iVar;
	BOOL ret = FALSE;

    // inititialize scale variant
	VariantInit( &iVar );
	V_VT( &iVar ) = VT_UI4;
	iVar.intVal = data;

	// send out the string
	short rets = m_CTineServer.EqpSendData( &iVar );
	if (rets == 0) ret = TRUE;
	
    VariantClear( &iVar );

	return( ret );
}


BOOL CMainDlg::sendDouble( double data )
{
	VARIANT dVar;
	BOOL ret = FALSE;

    // inititialize scale variant
	VariantInit( &dVar );
	V_VT( &dVar ) = VT_R8;
	dVar.dblVal = data;

	// send out the string
	short rets = m_CTineServer.EqpSendData( &dVar );
	if (rets == 0) ret = TRUE;
	
    VariantClear( &dVar );

	return( ret );
}



/////////////////////////////////////////////////////////////////////////////////////
// OUTDATED DOC
// This is the TINE server callback function. It is called whenever the TINE server 
// gets a data packet with our address (PITZ->Servername). In this function, the 
// logic for the 16 properties is wired.
//
void CMainDlg::OnEqpFcnSrvctrl1(LPCTSTR devName, LPCTSTR devProperty, long outArrayLen, long inArrayLen, short devAccess) 
{
    BOOL modified = FALSE;

	BOOL ret1;
	BOOL ret2=TRUE;
	CString msg;

    // make CStrings out of the LPCTSTRing parameters 
	CString devNam = CString(devName);
	CString devProp = CString(devProperty);

    // build up CStrings for the properties and the device name
	
	CString myName = CString("GRABSRV");
	
	CString myCamWidthProperty = CString("C_WIDTH"); 
	CString myCamHeightProperty = CString("C_HEIGHT"); 
	CString myCamBPPProperty = CString("C_BPP"); 
	CString myCamScaleProperty = CString("C_SCALE"); 
	CString myCamDynamicScaleProperty = CString("C_DYNAMICSCALE"); 
	CString myCamOrientationProperty = CString("C_ORIENTATION"); 
	
	CString myCamIDProperty = CString("C_CAMID"); 
	CString myCamNRefProperty = CString("C_NREF"); 
	CString myCamPRefProperty = CString("C_PREF"); 

	CString myCamPortProperty = CString("C_LOCALCAMPORT"); 
	
    
	CString myCamNameProperty = CString("C_CAMNAME"); 
	CString myCamExtTrigProperty = CString("C_EXTTRIG"); 
	CString myCamTrigMod5Property = CString("C_TRIGMOD5"); 

	CString myGetSpotProperty = CString("S_SPOTDATA"); // get spot data
	CString myGrabCompressionProperty = CString("S_COMPRESSION"); // read fourcc compression code

	CString myGrabSTARTCommand = CString("S_START");
	CString myGrabSTARTReadback = CString("S_isStarted");

	CString myGrabSTOPCommand = CString("S_STOP");
	CString myGrabSTOPReadback = CString("S_isStopped");

	CString myGrabUPDATECommand = CString("S_UPDATE");
	CString myGrabUPDATEReadback = CString("S_isUpdated");
	
	CString myGrabServername = CString("S_Servername");

	CString myGrabCameraActiveSinceProp = CString("C_ActiveSince");
	CString myGrabServerStartTimeProp = CString("S_StartTime");

	CString myGrabServerAvailVideodata = CString("S_availVideodata");

	if (devNam == myName) // is this our device ? 
	{
	 if (devProp == myCamWidthProperty) // C_WIDTH
	 {
		 int camwidth=m_iCurCamWidth;

		 if ((m_sCurCamOrient == "ROT90CW") || (m_sCurCamOrient == "ROT270CW") || (m_sCurCamOrient == "ROT90CWMIRRHORIZ"))
		 {
			 camwidth = m_iCurCamHeight;
		 }

		 ret1 = TRUE;
		 ret2 = TRUE;

		 if (devAccess & CA_WRITE) ret2 = getInteger( m_iNextCamWidth, 100, 1000 );
		 if (devAccess & CA_READ) ret1 = sendInteger( camwidth );
		 
		 if (ret2 == FALSE) m_CTineServer.EqpSetCompletion(2, "");
		 else if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else m_CTineServer.EqpSetCompletion(515, "Error!" );
	 }
	 else if (devProp == myCamDynamicScaleProperty) // C_DYNAMICSCALE
	 {
		 ret1 = TRUE;
		 ret2 = TRUE;

		 if (devAccess & CA_WRITE) ret2 = getDouble( m_dCurCamScale, 0.0001, 10000.0 );
		 if (devAccess & CA_READ) ret1 = sendDouble( m_dCurCamScale );
		 
		 if (ret2 == FALSE) m_CTineServer.EqpSetCompletion(2, "scale not accepted!");
		 else if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "scale set.");
		 else m_CTineServer.EqpSetCompletion(515, "Error!" );
	 }
	 else if (devProp == myCamHeightProperty) // C_HEIGHT
	 {
		 int camheight=m_iCurCamHeight;

		 if ((m_sCurCamOrient == "ROT90CW") || (m_sCurCamOrient == "ROT270CW") || (m_sCurCamOrient == "ROT90CWMIRRHORIZ"))
		 {
			 camheight = m_iCurCamWidth;
		 }
		 
		 ret1 = TRUE;
		 ret2 = TRUE;

		 if (devAccess & CA_WRITE) ret2 = getInteger( m_iNextCamHeight, 100, 1000 );
		 if (devAccess & CA_READ) ret1 = sendInteger( camheight );
		 
		 if (ret2 == FALSE) m_CTineServer.EqpSetCompletion(2, "");
		 else if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else m_CTineServer.EqpSetCompletion(515, "Error!" );
	 }

	 else if (devProp == myCamBPPProperty) // C_BPP
	 {
		 ret1 = TRUE;
		 ret2 = TRUE;

		 if (devAccess & CA_WRITE) ret2 = getInteger( m_iNextCamBPP, 8, 32 );
		 if (devAccess & CA_READ) ret1 = sendInteger( m_iCurCamBPP );
		 
		 if (ret2 == FALSE) m_CTineServer.EqpSetCompletion(2, "");
		 else if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else m_CTineServer.EqpSetCompletion(515, "Error!" );
	 }
	 else if (devProp == myGrabServerAvailVideodata ) // S_availVideodata
	 {
		 ret1 = TRUE;
		 _timeb tCurrentTime;
		 int videoAvail;
		 
		 ::_ftime( &tCurrentTime );

		 // calculate passed milliseconds between first and actual frame
		 double	passedmilliseconds = difftime(tCurrentTime.time, m_tLastFrameAcquiredAt.time) * 1000.0;

		 passedmilliseconds -= ((double)m_tLastFrameAcquiredAt.millitm);
		 passedmilliseconds += ((double)tCurrentTime.millitm);

		 if (passedmilliseconds > 2000.0) videoAvail = 0; else videoAvail = 1;

		 if (devAccess & CA_READ) ret1 = sendInteger( videoAvail );
		 
		 if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else m_CTineServer.EqpSetCompletion(515, "Error!" );
	 }
	 else if (devProp == myCamNRefProperty) // C_NREF
	 {
		 ret1 = TRUE;
		 ret2 = TRUE;

		 if (devAccess & CA_WRITE) ret2 = getInteger( m_iNextCamNRef, 0, 1000 );
		 if (devAccess & CA_READ) ret1 = sendInteger( m_iCurCamNRef );
		 
		 if (ret2 == FALSE) m_CTineServer.EqpSetCompletion(2, "");
		 else if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else m_CTineServer.EqpSetCompletion(515, "Error!" );
	 }
	 else if (devProp == myCamPRefProperty) // C_PREF
	 {
		 ret1 = TRUE;
		 ret2 = TRUE;

		 if (devAccess & CA_WRITE) ret2 = getInteger( m_iNextCamPRef, 0, 2000 );
		 if (devAccess & CA_READ) ret1 = sendInteger( m_iCurCamPRef );
		 
		 if (ret2 == FALSE) m_CTineServer.EqpSetCompletion(2, "");
		 else if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else m_CTineServer.EqpSetCompletion(515, "Error!" );
	 }
	 else if (devProp == myCamPortProperty) // C_LOCALCAMPORT
	 {
		 ret1 = TRUE;
		 ret2 = TRUE;

		 if (devAccess & CA_WRITE) ret2 = getInteger( m_iNextCamPort, 0, 3 );
		 if (devAccess & CA_READ) ret1 = sendInteger( m_iCurCamPort );
		 
		 else if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else m_CTineServer.EqpSetCompletion(515, "Error!" );
	 }
	 
	 else if (devProp == myCamIDProperty) // C_CAMID
	 {
		 ret1 = TRUE;
		 ret2 = TRUE;

		 if (devAccess & CA_WRITE) ret2 = getString( m_sNextCamID );
		 if (devAccess & CA_READ) ret1 = sendString( m_sCurCamID );

		 if (ret2 == FALSE) m_CTineServer.EqpSetCompletion(2, "");
		 else if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else m_CTineServer.EqpSetCompletion(515, "Error!" );
	 }

	 else if (devProp == myCamNameProperty) // C_CAMNAME
	 {
		 ret1 = TRUE;
		 ret2 = TRUE;

		 if (devAccess & CA_WRITE) ret2 = getString( m_sNextCamName );
		 if (devAccess & CA_READ) ret1 = sendString( m_sCurCamName );
	
		 if (ret2 == FALSE) m_CTineServer.EqpSetCompletion(2, "");
		 else if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else m_CTineServer.EqpSetCompletion(515, "Error!" );
	 }

	 else if (devProp == myCamOrientationProperty) // C_ORIENTATION
	 {
		 ret1 = TRUE;
		 ret2 = TRUE;

		 if (devAccess & CA_WRITE) ret2 = getString( m_sNextCamOrient );
		 if (devAccess & CA_READ) ret1 = sendString( m_sCurCamOrient );
		 
		 if (ret2 == FALSE) m_CTineServer.EqpSetCompletion(2, "");
		 else if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else m_CTineServer.EqpSetCompletion(515, "Error!" );
	 }

	 else if (devProp == myCamExtTrigProperty) // C_EXTTRIG
	 {
		 ret1 = TRUE;
		 ret2 = TRUE;

		 if (devAccess & CA_WRITE) ret2 = getInteger( m_iNextCamTrigger, 0, 1 );
		 if (devAccess & CA_READ) ret1 = sendInteger( m_iCurCamTrigger );
		 
		 if (ret2 == FALSE) m_CTineServer.EqpSetCompletion(2, "");
		 else if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else m_CTineServer.EqpSetCompletion(515, "Error!" );
	 }

	 else if (devProp == myCamTrigMod5Property) // C_TRIGMOD5
	 {
		 ret1 = TRUE;
		 ret2 = TRUE;

		 if (devAccess & CA_WRITE) ret2 = getInteger( m_iNextCamTrigMod5, 0, 1 );
		 if (devAccess & CA_READ) ret1 = sendInteger( m_iCurCamTrigMod5 );
		 
		 if (ret2 == FALSE) m_CTineServer.EqpSetCompletion(2, "");
		 else if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else m_CTineServer.EqpSetCompletion(515, "Error!" );
	 }

	 else if (devProp == myCamScaleProperty) // C_SCALE
	 {
		 ret1 = TRUE;
		 ret2 = TRUE;

		 if (devAccess & CA_WRITE) ret2 = getDouble( m_dNextCamScale, 0.0001, 10000.0 );
		 if (devAccess & CA_READ) ret1 = sendDouble( m_dCurCamScale );
		 
		 if (ret2 == FALSE) m_CTineServer.EqpSetCompletion(2, "");
		 else if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else m_CTineServer.EqpSetCompletion(515, "Error!" );
	 }
	 else if (devProp == myGrabServername) // S_Servername
	 {
		 CString servername = m_pIniFile->GetValue("DEFAULT", "TINECONTROLEQPNAME", "");

		 ret1 = TRUE;
		 ret2 = TRUE;

		 if (devAccess & CA_WRITE) ret2 = FALSE;
		 if (devAccess & CA_READ) ret1 = sendString( servername );
	
		 if (ret2 == FALSE) m_CTineServer.EqpSetCompletion(illegal_read_write, "");
		 else if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else m_CTineServer.EqpSetCompletion(515, "Error!" );
	 }
	 else if (devProp == myGrabCompressionProperty) // GRAB_COMPR
	 {
		 ret1 = TRUE;
		 
		 if (devAccess & CA_READ) ret1 = sendInteger( m_pCodec->ReturnFourccCodec() );
		 if (devAccess & CA_WRITE) ret1 = FALSE;
		 
		 if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else if (devAccess & CA_WRITE) m_CTineServer.EqpSetCompletion(73, "not_implemented" );
		 else m_CTineServer.EqpSetCompletion(515, "Unknown internal error!" );
	 }
	 else if (devProp == myGetSpotProperty) // 'GRAB_CAM.SPOTDATA' ? 
	 {
		 // SW! should not be necessary! (handled by windows message processing queue)
		 //
		 // make sure that we are not updating the values at the moment
		 //while( m_bFourierUpdate == TRUE )
		 //{
		 //	 ::Sleep(5);
 		 //}
		 short ret = 1;

		 if (devAccess & CA_READ)
		 {
			 SPOTDATA spData;

			 // fill spot data
			 spData.xm = (unsigned int) (m_fXMean*1000.0);
			 spData.ym = m_fYMean;
			 spData.xrms = m_fXRms;
			 spData.yrms = m_fYRms;

 			 VARIANT data, size;
			 SAFEARRAY *psa;
			 SAFEARRAYBOUND rgsabound[1];

			 // create safe array that is big enough to hold the data
			 rgsabound[0].lLbound = 0;
			 rgsabound[0].cElements = sizeof(SPOTDATA);
			 if ((psa=SafeArrayCreate(VT_I1,1,rgsabound)) != NULL) // allocate ok ? 
			 {
				 // initialize array variant
				 VariantInit( &data );
				 V_VT( &data ) = VT_I1 | VT_ARRAY;
				 V_ARRAY( &data ) = psa;
          
				 // fill memory with the spot data

				 memman.memcpysw( (char *) psa->pvData, (char *) &spData, sizeof(SPOTDATA));
			
				 // make a variant to specify the amount of data to be returned
				 VariantInit( &size );
				 size.vt = VT_I4;
				 size.lVal = sizeof(SPOTDATA);       // fill in the 'size' of the SPOTDATA structure

				 // call EqpSendDataEx() to send out the array
				 ret = m_CTineServer.EqpSendDataEx(&data,size);
		 
				 // clean up the variants
				 VariantClear( &data );
				 VariantClear( &size ); 
			 } 
			 else 
			 {
				 ret = 1;
			 }
		 }

		 if (devAccess & CA_WRITE) 
			m_CTineServer.EqpSetCompletion(73, "" );
		 else if (ret == 0) //success
			m_CTineServer.EqpSetCompletion(0, ""); // everything okay
		 else
			m_CTineServer.EqpSetCompletion(516,"Could not send spot data.");
	 }
	 else if (devProp == myGrabSTARTCommand)
	 {
		 unsigned int starti;
		 ret1 = FALSE;

		 if (devAccess & CA_WRITE) ret1 = getInteger( starti, 1, 1 );

		 if (starti ==1 && m_bGrabbingStarted == FALSE)
		 {
			 PostMessage( ID_START_GRABBING );
		 }

		 if (devAccess & CA_READ)
		 {
			 if (ret1 == TRUE) ret1 = sendInteger(1); else ret1 = sendInteger(0);
		 }

		 if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else m_CTineServer.EqpSetCompletion(515, "Internal error!" );
		 
	 }
	 else if (devProp == myGrabSTOPCommand)
	 {
		 unsigned int starti;

		 if (devAccess & CA_WRITE) ret1 = getInteger( starti, 1, 1 );

		 if (starti == 1 && m_bGrabbingStarted == TRUE)
		 {
			 PostMessage( ID_STOP_GRABBING );
		 }

		 if (devAccess & CA_READ)
		 {
			 if (ret1 == TRUE) ret1 = sendInteger(1); else ret1 = sendInteger(0);
		 }

		 if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else m_CTineServer.EqpSetCompletion(515, "Internal error!" );
		 
	 }
	 else if (devProp == myGrabUPDATECommand)
	 {
		 unsigned int starti;

		 if (devAccess & CA_WRITE) ret1 = getInteger( starti, 1, 1 );

		 if (starti == 1 && m_bGrabbingCanBeStarted == TRUE)
		 {
			 m_iUpdateSuccessful = 0;
			 PostMessage( ID_UPDATE_GRABBING );
		 }

		 if (devAccess & CA_READ)
		 {
			 if (ret1 == TRUE) ret1 = sendInteger(1); else ret1 = sendInteger(0);
		 }

		 if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else m_CTineServer.EqpSetCompletion(515, "Internal error!" );

	 }
	 else if (devProp == myGrabSTARTReadback)
	 {
		 int i1;
		 if (m_bGrabbingStarted == TRUE) i1 = 1; else i1 = 0;
		 ret1 = TRUE;
		 
		 if (devAccess & CA_READ) ret1 = sendInteger( i1 );
		 if (devAccess & CA_WRITE) ret1 = FALSE;
		 
		 if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else if (devAccess & CA_WRITE) m_CTineServer.EqpSetCompletion(73, "" );
		 else m_CTineServer.EqpSetCompletion(515, "Unknown internal error!" );

	 }
	 else if (devProp == myGrabSTOPReadback)
	 {
		 int i1;
		 if (m_bGrabbingStarted == TRUE) i1 = 0; else i1 = 1;
		 ret1 = TRUE;
		 
		 if (devAccess & CA_READ) ret1 = sendInteger( i1 );
		 if (devAccess & CA_WRITE) ret1 = FALSE;
		 
		 if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else if (devAccess & CA_WRITE) m_CTineServer.EqpSetCompletion(73, "" );
		 else m_CTineServer.EqpSetCompletion(515, "Unknown internal error!" );

	 }
	 else if (devProp == myGrabUPDATEReadback)
	 {
		 ret1 = TRUE;
		 
		 if (devAccess & CA_READ) ret1 = sendInteger( m_iUpdateSuccessful );
		 if (devAccess & CA_WRITE) ret1 = FALSE;
		 
		 if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else if (devAccess & CA_WRITE) m_CTineServer.EqpSetCompletion(73, "" );
		 else m_CTineServer.EqpSetCompletion(515, "Unknown internal error!" );

	 }
	 else if (devProp == myGrabCameraActiveSinceProp)
	 {
		 ret1 = TRUE;

		 // create time and date string
		 CString timestr = m_tCurCamStartTime.Format("%d.%m.%Y %H:%M:%S ");
		 timestr = "Camera "+m_sCurCamName+" active since "+timestr;
		 
		 if (devAccess & CA_READ) ret1 = sendString( timestr );
		 if (devAccess & CA_WRITE) ret1 = FALSE;
		 
		 if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else m_CTineServer.EqpSetCompletion(515, "Error!" );
	 }
	 else if (devProp == myGrabServerStartTimeProp)
	 {
 		 ret1 = TRUE;

		 // create time and date string
		 CString timestr = m_tServerStartTime.Format("%d.%m.%Y %H:%M:%S ");
		 timestr = "Server alive since "+timestr;

		 if (devAccess & CA_READ) ret1 = sendString( timestr );
		 if (devAccess & CA_WRITE) ret1 = FALSE;
		 
		 if (ret1 == TRUE) m_CTineServer.EqpSetCompletion(0, "");
		 else m_CTineServer.EqpSetCompletion(515, "Error!" );
	 }
	  else
	 {
       m_CTineServer.EqpSetCompletion(36, "Illegal property."); //illegal_property=36
	 }
	}

	AdjustNextCameraDisplayedSettings();
}

////////////////////////////////////////////////////////////////////////////////
//
// This function was needed for setting an application reference inside the main
// dialog in order to access the registry. Because we are no longer using the re-
// gistry, but a config file instead, this function is not used at the moment.
// It was left in for future upgrades, which might use the registry.
//
void CMainDlg::setApp(CGrabsrvApp *the_app)
{
	m_pApp = the_app;
}

////////////////////////////////////////////////////////////////////////////////
//
// This function initializes the network (socket) subsystem. It just calls the
// proper function in the socket encapsulation class. This function returns 
// TRUE if everything went fine, false otherwise.
//
// Parameters:
//   port               -  listen port for the server 
//   nummaxconnections  -  maximum number of simultaneous socket connections
//   tine_servername    -  name of tine "Device Server"
//   size_in_bytes      -  max. size in bytes of the video frame bits
//
BOOL CMainDlg::InitializeNetwork(int port, int nummaxconnections, int enabled2, int port2, int nummaxc2, CString tine_servername, int size_in_bytes)
{
 BOOL retval = TRUE;
 BOOL ret;

 ret = m_CSockEncap.Init(port, nummaxconnections, tine_servername, size_in_bytes, this);
 if (ret == FALSE) retval = FALSE;

 m_CCheckLossyEnabled.SetCheck(0);
 m_CStaticLossyEnabled.EnableWindow(FALSE);
 m_CEditLossyClients.EnableWindow(FALSE);
 m_CStaticLossyEnabled1.EnableWindow(FALSE);
 
 if (enabled2 == 1) 
 {
	 ret = m_CSockEncap2.Init(port2, nummaxc2, this);
	 if (ret == FALSE) retval = FALSE;
 	 else
	 {
		 m_CCheckLossyEnabled.SetCheck(1);
		 m_CStaticLossyEnabled1.EnableWindow(TRUE);
		 m_CStaticLossyEnabled.EnableWindow(TRUE);
		 m_CEditLossyClients.EnableWindow(TRUE);
	 }
 }
 return( retval );
}

////////////////////////////////////////////////////////////////////////////////
//
// This function deinitializes the network (socket) subsystem. It just calls the
// proper function in the socket encapsulation class. This function returns 
// TRUE if everything went fine, false otherwise.
//
BOOL CMainDlg::DeinitializeNetwork()
{
 PrintServerMessage("Deinitializing network...");
 BOOL retval = TRUE;
 BOOL ret;

 ret = m_CSockEncap.Done();
 if (ret == FALSE) retval = FALSE;
 if (m_bLossyEnabled == TRUE)
 {
	 ret = m_CSockEncap2.Done();
     if (ret == FALSE) retval = FALSE;
 }
 return( retval );
}

////////////////////////////////////////////////////////////////////////////////
//
// This function just deinitializes the TINE server by calling the proper 
// function of the server ActiveX control. The function returns always TRUE.
//
BOOL CMainDlg::DeinitializeTine()
{
 PrintServerMessage("Deinitializing TINE control connections...");
 m_CTineServer.SetEnabled(FALSE);

 return TRUE;
}

////////////////////////////////////////////////////////////////////////////////
//
// This function is called just before the main dialog is shown on screen. It was
// needed for proper updating of the number of clients control. It also calls
// the base class function.
//
void CMainDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	// tell the socket encapsulation that it is allowed to update
	// the number of clients
	m_CSockEncap.doUpdateNumClients( TRUE );
	if (m_bLossyEnabled == TRUE) m_CSockEncap2.doUpdateNumClients( TRUE );

    // call base class
	CDialog::OnShowWindow(bShow, nStatus);
}

////////////////////////////////////////////////////////////////////////////////
//
// This function is called via a Windows message by the CSendReceive class. The
// CSendReceive class just tells us that the client the CSendReceive is responsible
// for is no longer connected. It calls the proper 'RemoveClient' function from 
// the socket encapsulation class. In the lParam parameter the reference of the 
// proper CSendReceive instance is transferred.
//
LRESULT CMainDlg::OnRemoveClient(WPARAM wParam, LPARAM lParam)
{
 if (wParam == ID_REMOVE_CLIENT)
 {
  m_CSockEncap.RemoveClient((CSendReceive *) lParam );
 }
 if (wParam == ID_REMOVE_CLIENT_2)
 {
  m_CSockEncap2.RemoveClient((CSendReceive2 *) lParam );
 }

 return( 0 );
}

////////////////////////////////////////////////////////////////////////////////
//
// This function is just needed for proper showing the 'About' dialog. It was 
// generated by the Visual C++ class wizard.
//
void CMainDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}


BOOL CMainDlg::InitializeIniFile()
{
 CString filepath;

 // instantiate ini file
 m_pIniFile = new CIniEx();
 if (m_pIniFile == NULL) return FALSE;
 
 //	writeWhenChange, createIfNotExist, noCaseSensitive, makeBackup
 m_pIniFile->OpenAtExeDirectory( "Grabsrv2.cfg", FALSE, FALSE, TRUE, FALSE);

 // try to retrieve a value that must exist in order to know
 // whether we have created a empty file 
 CString maintest = m_pIniFile->GetValue("DEFAULT", "BOARDNUMBER", "empty");

 if (maintest == "empty") // aha, no values in the file yet, so fill the file with
 {                        // default values 
 
	 AfxMessageBox("Maintest == empty!!!");
	 
  // it seems that there was no ini file, so it was automatically created and
  // now we fill the ini file with default values

  // set main section
  m_pIniFile->SetValue("DEFAULT", "BOARDNUMBER", "0");
  m_pIniFile->SetValue("DEFAULT", "SYSTEMNUMBER", "0");
  m_pIniFile->SetValue("DEFAULT", "MAXCLIENTS", "255");
  m_pIniFile->SetValue("DEFAULT", "LISTENPORTNUMBER", "31777");

  m_pIniFile->SetValue("DEFAULT", "MAXCLIENTSLOSSY", "255");
  m_pIniFile->SetValue("DEFAULT", "LISTENPORTNUMBERLOSSY", "31778");
  m_pIniFile->SetValue("DEFAULT", "LOSSYENABLED", "1");

  m_pIniFile->SetValue("DEFAULT", "ExternalTrigger", "TRUE");
  m_pIniFile->SetValue("DEFAULT", "TriggerMod5", "FALSE");
  m_pIniFile->SetValue("DEFAULT", "JPEGQuality", "60");


  char buffer[101];
  unsigned long length=100;

  ::GetComputerName( buffer, &length);

  CString tinecontrolname = CString(buffer);
  CString tineframename = tinecontrolname + CString("F");
  tineframename.MakeUpper();
  tinecontrolname.MakeUpper();

  m_pIniFile->SetValue("DEFAULT", "TINEFRAMEEQPNAME", tineframename );
  m_pIniFile->SetValue("DEFAULT", "TINECONTROLEQPNAME", tinecontrolname );
  m_pIniFile->SetValueInt("DEFAULT", "TINEPORTNUMBER", 11 );
  m_pIniFile->SetValue("DEFAULT", "TINECONTEXT", "PITZ" );


  m_pIniFile->SetValue("CameraSettings", "Name", "Camera 0");
  m_pIniFile->SetValue("CameraSettings", "Scale", "1.0000");
  m_pIniFile->SetValue("CameraSettings", "Orientation", "NORM");
  m_pIniFile->SetValueInt("CameraSettings", "NegativeReference", 200);
  m_pIniFile->SetValueInt("CameraSettings", "PositiveReference", 800);
  m_pIniFile->SetValueInt("CameraSettings", "Width", 768);
  m_pIniFile->SetValueInt("CameraSettings", "Height", 574);
  m_pIniFile->SetValueInt("CameraSettings", "BPP", 8);
  m_pIniFile->SetValueInt("CameraSettings", "LocalCamPort", 3);
  m_pIniFile->SetValue("CameraSettings", "CAMID", "0x01000000");

  BOOL ret4 = m_pIniFile->WriteFile();
  if (ret4 == FALSE) PrintServerMessage("Error on saving settings to config file in InitializeIniFile .");

 }

 return TRUE;
}

void CMainDlg::DeinitializeIniFile()
{
 if (m_pIniFile != NULL)
 {
  // flush the file to disk
  m_pIniFile->WriteFile();
 
  // delete the initialization file class instance
  delete m_pIniFile;
 }
 m_pIniFile = NULL;
}

void CMainDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnKeyDown(nChar, nRepCnt, nFlags);
}

BOOL CMainDlg::OnQueryEndSession() 
{
	//if (!CDialog::OnQueryEndSession())
		//return FALSE;
	
	// TODO: Add your specialized query end session code here
	
	return TRUE;
}

void CMainDlg::OnEndSession(BOOL bEnding) 
{
	//CDialog::OnEndSession(bEnding);
	
	// TODO: Add your message handler code here
	
}

LRESULT CMainDlg::OnMessageStartGrabbing(WPARAM wParam, LPARAM lParam)
{
 if (m_bGrabbingStarted == FALSE && m_bGrabbingCanBeStarted == TRUE)
 {
	 OnButtonStartGrabbing();
 }

 return( 0 );
}

LRESULT CMainDlg::OnMessageStopGrabbing(WPARAM wParam, LPARAM lParam)
{
 if (m_bGrabbingStarted == TRUE)
 {
  OnButtonStopGrabbing();
 }

 return( 0 );
}


LRESULT CMainDlg::OnMessageUpdateGrabbing(WPARAM wParam, LPARAM lParam)
{
	if (m_bGrabbingStarted == TRUE)
	{
		OnButtonStopGrabbing();
	}

	UpdateCameraSettings();

	OnButtonStartGrabbing();

	m_iUpdateSuccessful = 1;
 
	return( 0 );
}


LRESULT CMainDlg::OnMessageCloseServer(WPARAM wParam, LPARAM lParam)
{
 OnButtonClose();
 return( 0 );
}


void CMainDlg::OnTimer(UINT nIDEvent) 
{
	switch( nIDEvent )
	{
	 case  WM_TIMER_SETENVVAR: // 
				m_bDeadManFlipFlop = TRUE;
		   break;

	 case  WM_TIMER_CLEARTINE:
		
				m_bTineTransferRunning = FALSE;
				
				UpdateTineTransferControl();
				
				{
					BOOL r = KillTimer(m_nTineActiveTimer);
					m_nTineActiveTimer = 0;
				}
		   break;


	 default: //PrintServerMessage("Unsupported TimerID");
		      break;

	}

	// call base class
	CDialog::OnTimer(nIDEvent);
}

UINT CMainDlg::threadDeadManFlipFlopStatic(LPVOID pParam)
{
  return reinterpret_cast<CMainDlg *>(pParam)->threadDeadManFlipFlop();
}

UINT CMainDlg::threadDeadManFlipFlop()
{
 LONG ret, ret1, ret2;
 DWORD resv=0;
 HKEY hKey;

 m_bDeadManFlipFlopIsActive = TRUE;
 while( m_bDeadManFlipFlopRunning == TRUE)
 {
  if (m_bDeadManFlipFlop == TRUE)
  {
   ret = RegOpenKeyEx( HKEY_LOCAL_MACHINE,
         "SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment",
         0, KEY_SET_VALUE, &hKey );

   if (ret == ERROR_SUCCESS)
   {
       ret = RegSetValueEx(hKey, "GRABSRV2", resv, REG_SZ, (const BYTE *) "on", 3);
       ret1 = RegFlushKey( hKey );
       ret2 = RegCloseKey( hKey );

       if (ret == ERROR_SUCCESS && ret1 == ERROR_SUCCESS && ret2 == ERROR_SUCCESS)
       {
         //  SendMessageTimeout(HWND_BROADCAST, WM_SETTINGCHANGE, 0, (LPARAM) "Environment", SMTO_ABORTIFHUNG, 5000, &dwReturnValue);
       }
       
   }
   m_bDeadManFlipFlop = FALSE;
  }//if
  ::Sleep(4700);
 }//while
 m_bDeadManFlipFlopIsActive = FALSE;

 return( 0 );
}

void CMainDlg::AdjustCurrentCameraDisplayedSettings()
{
	m_CEditCurCamName.SetWindowText( (LPCTSTR) m_sCurCamName );
	m_CEditCurCamOrient.SetWindowText( (LPCTSTR) m_sCurCamOrient );
	m_CEditCurCamID.SetWindowText( (LPCTSTR) m_sCurCamID );

	CString tmp;

	if (m_iCurCamTrigger == TRUE) 
		m_CCheckCurCamExternalTrigger.SetCheck(1); 
	else
		m_CCheckCurCamExternalTrigger.SetCheck(0);

	if (m_iCurCamTrigMod5 == TRUE) 
		m_CCheckCurCamTriggerMod5.SetCheck(1); 
	else
		m_CCheckCurCamTriggerMod5.SetCheck(0);

	tmp.Format("%f", m_dCurCamScale );
	m_CEditCurCamScale.SetWindowText( (LPCTSTR) tmp );

	tmp.Format("%d", m_iCurCamNRef );
	m_CEditCurCamNRef.SetWindowText( (LPCTSTR) tmp );

	tmp.Format("%d", m_iCurCamPRef );
	m_CEditCurCamPRef.SetWindowText( (LPCTSTR) tmp );

	tmp.Format("%d", m_iCurCamWidth );
	m_CEditCurCamWidth.SetWindowText( (LPCTSTR) tmp );

	tmp.Format("%d", m_iCurCamHeight );
	m_CEditCurCamHeight.SetWindowText( (LPCTSTR) tmp );

	tmp.Format("%d", m_iCurCamBPP );
	m_CEditCurCamBPP.SetWindowText( (LPCTSTR) tmp );

	tmp.Format("%d", m_iCurCamPort );
	m_CEditCurCamPort.SetWindowText( (LPCTSTR) tmp );
}

void CMainDlg::AdjustNextCameraDisplayedSettings()
{
	m_CEditNewCamName.SetWindowText( (LPCTSTR) m_sNextCamName );
	m_CEditNewCamOrient.SetWindowText( (LPCTSTR) m_sNextCamOrient );
	m_CEditNewCamID.SetWindowText( (LPCTSTR) m_sNextCamID );

	if (m_iNextCamTrigger == TRUE) 
		m_CCheckNewCamExternalTrigger.SetCheck(1); 
	else
		m_CCheckNewCamExternalTrigger.SetCheck(0);

	if (m_iNextCamTrigMod5 == TRUE) 
		m_CCheckNewCamTriggerMod5.SetCheck(1); 
	else
		m_CCheckNewCamTriggerMod5.SetCheck(0);


	CString tmp;

	tmp.Format("%f", m_dNextCamScale );
	m_CEditNewCamScale.SetWindowText( (LPCTSTR) tmp );

	tmp.Format("%d", m_iNextCamNRef );
	m_CEditNewCamNRef.SetWindowText( (LPCTSTR) tmp );

	tmp.Format("%d", m_iNextCamPRef );
	m_CEditNewCamPRef.SetWindowText( (LPCTSTR) tmp );

	tmp.Format("%d", m_iNextCamWidth );
	m_CEditNewCamWidth.SetWindowText( (LPCTSTR) tmp );

	tmp.Format("%d", m_iNextCamHeight );
	m_CEditNewCamHeight.SetWindowText( (LPCTSTR) tmp );

	tmp.Format("%d", m_iNextCamBPP );
	m_CEditNewCamBPP.SetWindowText( (LPCTSTR) tmp );

	tmp.Format("%d", m_iNextCamPort );
	m_CEditNewCamPort.SetWindowText( (LPCTSTR) tmp );
}

CString TranslateBoolInt( int b )
{
 if (b == 0) return( "FALSE" ); else return("TRUE");
}


BOOL CMainDlg::UpdateCameraSettings()
{
	BOOL reInit = TRUE; //SW! June 27, 2006 ALWAYS do a reinitialisation
	BOOL retval = TRUE;
	BOOL reInitFailed = FALSE;

	CString			m_sBakCamName;
	CString			m_sBakCamID;
	unsigned int    m_iBakCamWidth;
	unsigned int	m_iBakCamHeight;
	unsigned int	m_iBakCamBPP;
	unsigned int	m_iBakCamPort;
	double			m_dBakCamScale;
	unsigned int	m_iBakCamPRef;
	unsigned int	m_iBakCamNRef;
	CString			m_sBakCamOrient;
	unsigned int    m_iBakCamTrigger;
	unsigned int    m_iBakCamTrigMod5;

	m_sBakCamName = m_sCurCamName;
	m_sBakCamID = m_sCurCamID;
	m_iBakCamWidth = m_iCurCamWidth;
	m_iBakCamHeight = m_iCurCamHeight;
	m_iBakCamBPP = m_iCurCamBPP;
	m_iBakCamPort = m_iCurCamPort;
	m_dBakCamScale = m_dCurCamScale;
	m_iBakCamPRef = m_iCurCamPRef;
	m_iBakCamNRef = m_iCurCamNRef;
	m_sBakCamOrient = m_sCurCamOrient; 
	m_iBakCamTrigger = m_iCurCamTrigger;
	m_iBakCamTrigMod5 = m_iCurCamTrigMod5;

	if ((m_iCurCamPRef != m_iNextCamPRef) || 
		(m_iCurCamNRef != m_iNextCamNRef) || 
		(m_iCurCamTrigger != m_iNextCamTrigger) || 
		(m_iCurCamTrigMod5 != m_iNextCamTrigMod5) )
	{
		reInit = TRUE;
	}

	m_sCurCamName = m_sNextCamName;
	m_sCurCamID = m_sNextCamID;
	m_iCurCamWidth = m_iNextCamWidth;
	m_iCurCamHeight = m_iNextCamHeight;
	m_iCurCamBPP = m_iNextCamBPP;
	m_iCurCamPort = m_iNextCamPort;
	m_dCurCamScale = m_dNextCamScale;
	m_iCurCamPRef = m_iNextCamPRef;
	m_iCurCamNRef = m_iNextCamNRef;
	m_sCurCamOrient = m_sNextCamOrient; 
	m_iCurCamTrigger = m_iNextCamTrigger;
	m_iCurCamTrigMod5 = m_iNextCamTrigMod5;

	m_pIniFile->SetValue("CameraSettings", "Name", m_sCurCamName);
	m_pIniFile->SetValue("CameraSettings", "CAMID", m_sCurCamID);
	m_pIniFile->SetValue("CameraSettings", "Orientation", m_sCurCamOrient);
	m_pIniFile->SetValueDouble("CameraSettings", "Scale", m_dCurCamScale);

	m_pIniFile->SetValueInt("CameraSettings", "Width", m_iCurCamWidth);
	m_pIniFile->SetValueInt("CameraSettings", "Height", m_iCurCamHeight);
	m_pIniFile->SetValueInt("CameraSettings", "BPP", m_iCurCamBPP);
	m_pIniFile->SetValueInt("CameraSettings", "LocalCamPort", m_iCurCamPort);
	m_pIniFile->SetValueInt("CameraSettings", "PositiveReference", m_iCurCamPRef);
	m_pIniFile->SetValueInt("CameraSettings", "NegativeReference", m_iCurCamNRef);
	
	m_pIniFile->SetValue("DEFAULT", "ExternalTrigger", TranslateBoolInt(m_iCurCamTrigger) );
	m_pIniFile->SetValue("DEFAULT", "TriggerMod5", TranslateBoolInt(m_iCurCamTrigMod5) );

    BOOL ret4 = m_pIniFile->WriteFile();
    if (ret4 == FALSE) PrintServerMessage("Error on saving settings to config file in UpdateCameraSettings.");

	if (reInit == TRUE)
	{
	   // deinitialize everything
	   DeinitializeCompressionCodec(); // shut down compression codec
	   DeinitializeITEX(); // shut down ITEX grabber
	   
       // initialize grabbing subsystem and print error
       // if it could not be initialized
   	   
	   m_pGrab = NULL;
	   BOOL ret = InitializeITEXGrabber();
       if (ret == TRUE) 
			PrintServerMessage("Successful reinitialized grabber card for new settings.");
       else
	   {
           reInitFailed = TRUE;
	   }

       // initialize compression codec and print error
       // if it could not be initialized
       m_pCodec = NULL;
       ret = InitializeCompressionCodec(m_iGrabWidth, m_iGrabHeight, m_iGrabBpp);
       if (ret == TRUE) 
			PrintServerMessage("Successful initialized compression codec for new settings.");
	   else
	   {
			reInitFailed = TRUE;
	   }

	   // SW! !!! Sept 13, 2005: You MUST not set total size of a frame (by grabber) to more than in
	   // InitializeNetwork (inside OnInitDialog) was given!!!
	   //
	   // Otherwise a function like UpdateNetworkSubsystem must be created !!!

       if (reInitFailed == TRUE)
	   {
			m_bGrabbingCanBeStarted = FALSE;
			m_CButtonStartGrabbing.EnableWindow(FALSE);
			m_CButtonStopGrabbing.EnableWindow(FALSE);
	   }
	    else
   	   {
			m_bGrabbingCanBeStarted = TRUE;
			m_CButtonStartGrabbing.EnableWindow(TRUE);
			m_CButtonStopGrabbing.EnableWindow(FALSE);
			retval = TRUE;
       }

	} 
	  else retval = TRUE;


    // SW! always update camera port
	// SW! June 27, 2006 !!!

	//if (m_iCurCamPort != m_iBakCamPort)
	//{
	//	if (m_pGrab != NULL) m_pGrab->setCamera( m_iCurCamPort );
	//}

    m_tCurCamStartTime = CTime::GetCurrentTime();

    AdjustCurrentCameraDisplayedSettings();
    AdjustNextCameraDisplayedSettings();

	if (m_sBakCamName != m_sCurCamName) ScheduleProperty( (char *) (LPCTSTR) m_CTineServer.GetEqpName(), "C_CAMNAME");
	if (m_sBakCamID != m_sCurCamID) ScheduleProperty( (char *) (LPCTSTR) m_CTineServer.GetEqpName(), "C_CAMID");
	if (m_iBakCamWidth != m_iCurCamWidth) ScheduleProperty( (char *) (LPCTSTR) m_CTineServer.GetEqpName(), "C_WIDTH");
	if (m_iBakCamHeight != m_iCurCamHeight) ScheduleProperty( (char *) (LPCTSTR) m_CTineServer.GetEqpName(), "C_HEIGHT");
	if (m_iBakCamBPP != m_iCurCamBPP) ScheduleProperty((char *) (LPCTSTR) m_CTineServer.GetEqpName(), "C_BPP");
	if (m_iBakCamPort != m_iCurCamPort) ScheduleProperty((char *) (LPCTSTR) m_CTineServer.GetEqpName(), "C_LOCALCAMPORT");
	if (m_dBakCamScale != m_dCurCamScale) ScheduleProperty((char *) (LPCTSTR) m_CTineServer.GetEqpName(), "C_SCALE");
	if (m_iBakCamPRef != m_iCurCamPRef) ScheduleProperty((char *) (LPCTSTR) m_CTineServer.GetEqpName(), "C_PREF");
	if (m_iBakCamNRef != m_iCurCamNRef) ScheduleProperty((char *) (LPCTSTR) m_CTineServer.GetEqpName(), "C_NREF");
	if (m_sBakCamOrient != m_sCurCamOrient) ScheduleProperty((char *) (LPCTSTR) m_CTineServer.GetEqpName(), "C_ORIENTATION"); 
	if (m_iBakCamTrigger != m_iCurCamTrigger) ScheduleProperty((char *) (LPCTSTR) m_CTineServer.GetEqpName(), "C_EXTTRIG");
	if (m_iBakCamTrigMod5 != m_iCurCamTrigMod5) ScheduleProperty((char *) (LPCTSTR) m_CTineServer.GetEqpName(), "C_TRIGMOD5");

	return( retval );
}


void CMainDlg::UpdateTineActive()
{
  m_bTineTransferRunning = TRUE;
  if (m_nTineActiveTimer != 0) KillTimer( m_nTineActiveTimer );
  m_nTineActiveTimer = SetTimer( WM_TIMER_CLEARTINE, 2000, 0);

  UpdateTineTransferControl();
}

void CMainDlg::UpdateTineTransferControl()
{
	if (m_bTineTransferRunning == TRUE)
	{
		m_CEditTINEActive.SetWindowText( (LPCTSTR) ">= 1");
	}
	else
	{
		m_CEditTINEActive.SetWindowText( (LPCTSTR) "0");
	}
}
