// AdditionalInformation.cpp : implementation file
//

#include "stdafx.h"
#include "headers.h"
#include "resource.h"
#include "CATineDlg.h"
#include "videoclnt.h"
#include "AdditionalInformation.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAdditionalInformation dialog


CAdditionalInformation::CAdditionalInformation(int numprops, struct AdditionalProperty *addprops, CWnd* pParent /*=NULL*/)
	: CDialog(CAdditionalInformation::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAdditionalInformation)
	//}}AFX_DATA_INIT
	//m_bDoocsValuesSet = FALSE;
	m_pAdditionalProperties = addprops;
    m_iNumProperties = numprops;
}


void CAdditionalInformation::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAdditionalInformation)
	DDX_Control(pDX, IDC_EDIT_PROP15, m_CEditProp15Val);
	DDX_Control(pDX, IDC_EDIT_PROP14, m_CEditProp14Val);
	DDX_Control(pDX, IDC_EDIT_PROP13, m_CEditProp13Val);
	DDX_Control(pDX, IDC_EDIT_PROP12, m_CEditProp12Val);
	DDX_Control(pDX, IDC_EDIT_PROP11, m_CEditProp11Val);
	DDX_Control(pDX, IDC_EDIT_PROP8, m_CEditProp8Val);
	DDX_Control(pDX, IDC_EDIT_PROP7, m_CEditProp7Val);
	DDX_Control(pDX, IDC_EDIT_PROP4, m_CEditProp4Val);
	DDX_Control(pDX, IDC_EDIT5_PROP10, m_CEditProp10Val);
	DDX_Control(pDX, IDC_EDIT5_PROP6, m_CEditProp6Val);
	DDX_Control(pDX, IDC_EDIT4_PROP9, m_CEditProp9Val);
	DDX_Control(pDX, IDC_EDIT4_PROP5, m_CEditProp5Val);
	DDX_Control(pDX, IDC_EDIT3_PROP3, m_CEditProp3Val);
	DDX_Control(pDX, IDC_EDIT2_PROP2, m_CEditProp2Val);
	DDX_Control(pDX, IDC_EDIT2_PROP1, m_CEditProp1Val);
	DDX_Control(pDX, IDC_STATIC_UNIT9, m_CStaticProp9Unit);
	DDX_Control(pDX, IDC_STATIC_UNIT8, m_CStaticProp8Unit);
	DDX_Control(pDX, IDC_STATIC_UNIT7, m_CStaticProp7Unit);
	DDX_Control(pDX, IDC_STATIC_UNIT6, m_CStaticProp6Unit);
	DDX_Control(pDX, IDC_STATIC_UNIT5, m_CStaticProp5Unit);
	DDX_Control(pDX, IDC_STATIC_UNIT4, m_CStaticProp4Unit);
	DDX_Control(pDX, IDC_STATIC_UNIT3, m_CStaticProp3Unit);
	DDX_Control(pDX, IDC_STATIC_UNIT2, m_CStaticProp2Unit);
	DDX_Control(pDX, IDC_STATIC_UNIT15, m_CStaticProp15Unit);
	DDX_Control(pDX, IDC_STATIC_UNIT14, m_CStaticProp14Unit);
	DDX_Control(pDX, IDC_STATIC_UNIT13, m_CStaticProp13Unit);
	DDX_Control(pDX, IDC_STATIC_UNIT12, m_CStaticProp12Unit);
	DDX_Control(pDX, IDC_STATIC_UNIT11, m_CStaticProp11Unit);
	DDX_Control(pDX, IDC_STATIC_UNIT10, m_CStaticProp10Unit);
	DDX_Control(pDX, IDC_STATIC_UNIT1, m_CStaticProp1Unit);
	DDX_Control(pDX, IDC_STATIC_PROP9, m_CStaticProp9Text);
	DDX_Control(pDX, IDC_STATIC_PROP8, m_CStaticProp8Text);
	DDX_Control(pDX, IDC_STATIC_PROP6, m_CStaticProp6Text);
	DDX_Control(pDX, IDC_STATIC_PROP7, m_CStaticProp7Text);
	DDX_Control(pDX, IDC_STATIC_PROP5, m_CStaticProp5Text);
	DDX_Control(pDX, IDC_STATIC_PROP4, m_CStaticProp4Text);
	DDX_Control(pDX, IDC_STATIC_PROP3, m_CStaticProp3Text);
	DDX_Control(pDX, IDC_STATIC_PROP2, m_CStaticProp2Text);
	DDX_Control(pDX, IDC_STATIC_PROP15, m_CStaticProp15Text);
	DDX_Control(pDX, IDC_STATIC_PROP14, m_CStaticProp14Text);
	DDX_Control(pDX, IDC_STATIC_PROP13, m_CStaticProp13Text);
	DDX_Control(pDX, IDC_STATIC_PROP12, m_CStaticProp12Text);
	DDX_Control(pDX, IDC_STATIC_PROP11, m_CStaticProp11Text);
	DDX_Control(pDX, IDC_STATIC_PROP10, m_CStaticProp10Text);
	DDX_Control(pDX, IDC_STATIC_PROP1, m_CStaticProp1Text);
	DDX_Control(pDX, IDC_EDIT_LASERPULSES, m_CEditLaserPulses);
	DDX_Control(pDX, IDC_EDIT7_NUMAMP, m_CEditNumAmp);
	DDX_Control(pDX, IDC_EDIT6_SPOTSIZEVC, m_CEditSpotSizeVC);
	DDX_Control(pDX, IDC_EDIT_CHARGESS, m_CEditChargeSS);
	DDX_Control(pDX, IDC_EDIT_CHARGEDC, m_CEditChargeDC);
	DDX_Control(pDX, IDC_EDIT_CAMERAGAIN, m_CEditCameraGain);
	DDX_Control(pDX, IDC_EDIT1, m_CEditInformation);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAdditionalInformation, CDialog)
	//{{AFX_MSG_MAP(CAdditionalInformation)
	ON_BN_CLICKED(ID_OK_1, OnOk1)
	ON_EN_SETFOCUS(IDC_EDIT1, OnSetfocusEditAdditional)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAdditionalInformation message handlers

/////////////////////////////////////////////////////////////////////////////
// OnOK
//
// This function is empty so that the dialog can only be exited by the Button 
// event OnOK1.
// 
void CAdditionalInformation::OnOK() 
{
}

/////////////////////////////////////////////////////////////////////////////
// OnInitDialog
//
// This function initializes the dialog before it is shown.
// 
BOOL CAdditionalInformation::OnInitDialog() 
{
	// call base class
	CDialog::OnInitDialog();

    // to be manual filled in values
	// so initialize them empty
    m_CEditInformation.SetWindowText("(put information here)");	
	m_CEditCameraGain.SetWindowText("");
	m_CEditChargeDC.SetWindowText("");
	m_CEditChargeSS.SetWindowText("");
	m_CEditLaserPulses.SetWindowText("");
	m_CEditNumAmp.SetWindowText("");
	m_CEditSpotSizeVC.SetWindowText("");

    // limit manual fields to 5 chars
	m_CEditCameraGain.SetLimitText(5);
	m_CEditChargeDC.SetLimitText(5);
	m_CEditChargeSS.SetLimitText(5);
	m_CEditNumAmp.SetLimitText(5);
	m_CEditSpotSizeVC.SetLimitText(5);
	m_CEditLaserPulses.SetLimitText(5);

 m_CStaticProp1Text.ModifyStyle(WS_VISIBLE,0);
 m_CEditProp1Val.ModifyStyle(WS_VISIBLE,0);
 m_CStaticProp1Unit.ModifyStyle(WS_VISIBLE,0);
  
 m_CStaticProp2Text.ModifyStyle(WS_VISIBLE,0);
 m_CEditProp2Val.ModifyStyle(WS_VISIBLE,0);
 m_CStaticProp2Unit.ModifyStyle(WS_VISIBLE,0);
  
 m_CStaticProp3Text.ModifyStyle(WS_VISIBLE,0);
 m_CEditProp3Val.ModifyStyle(WS_VISIBLE,0);
 m_CStaticProp3Unit.ModifyStyle(WS_VISIBLE,0);
  
 m_CStaticProp4Text.ModifyStyle(WS_VISIBLE,0);
 m_CEditProp4Val.ModifyStyle(WS_VISIBLE,0);
 m_CStaticProp4Unit.ModifyStyle(WS_VISIBLE,0);
  
 m_CStaticProp5Text.ModifyStyle(WS_VISIBLE,0);
 m_CEditProp5Val.ModifyStyle(WS_VISIBLE,0);
 m_CStaticProp5Unit.ModifyStyle(WS_VISIBLE,0);
  
 m_CStaticProp6Text.ModifyStyle(WS_VISIBLE,0);
 m_CEditProp6Val.ModifyStyle(WS_VISIBLE,0);
 m_CStaticProp6Unit.ModifyStyle(WS_VISIBLE,0);
  
 m_CStaticProp7Text.ModifyStyle(WS_VISIBLE,0);
 m_CEditProp7Val.ModifyStyle(WS_VISIBLE,0);
 m_CStaticProp7Unit.ModifyStyle(WS_VISIBLE,0);
  
 m_CStaticProp8Text.ModifyStyle(WS_VISIBLE,0);
 m_CEditProp8Val.ModifyStyle(WS_VISIBLE,0);
 m_CStaticProp8Unit.ModifyStyle(WS_VISIBLE,0);
  
 m_CStaticProp9Text.ModifyStyle(WS_VISIBLE,0);
 m_CEditProp9Val.ModifyStyle(WS_VISIBLE,0);
 m_CStaticProp9Unit.ModifyStyle(WS_VISIBLE,0);
  
 m_CStaticProp10Text.ModifyStyle(WS_VISIBLE,0);
 m_CEditProp10Val.ModifyStyle(WS_VISIBLE,0);
 m_CStaticProp10Unit.ModifyStyle(WS_VISIBLE,0);
  
 m_CStaticProp11Text.ModifyStyle(WS_VISIBLE,0);
 m_CEditProp11Val.ModifyStyle(WS_VISIBLE,0);
 m_CStaticProp11Unit.ModifyStyle(WS_VISIBLE,0);
  
 m_CStaticProp12Text.ModifyStyle(WS_VISIBLE,0);
 m_CEditProp12Val.ModifyStyle(WS_VISIBLE,0);
 m_CStaticProp12Unit.ModifyStyle(WS_VISIBLE,0);

 m_CStaticProp13Text.ModifyStyle(WS_VISIBLE,0);
 m_CEditProp13Val.ModifyStyle(WS_VISIBLE,0);
 m_CStaticProp13Unit.ModifyStyle(WS_VISIBLE,0);

 m_CStaticProp14Text.ModifyStyle(WS_VISIBLE,0);
 m_CEditProp14Val.ModifyStyle(WS_VISIBLE,0);
 m_CStaticProp14Unit.ModifyStyle(WS_VISIBLE,0);

 m_CStaticProp15Text.ModifyStyle(WS_VISIBLE,0);
 m_CEditProp15Val.ModifyStyle(WS_VISIBLE,0);
 m_CStaticProp15Unit.ModifyStyle(WS_VISIBLE,0);

	if (m_iNumProperties > 0)
	{
		int cnt=0;
		for (int i=0;i<NUM_MAX_ADDITIONAL_PROPERTIES;i++)
		{
			if (m_pAdditionalProperties[i].enabled == TRUE) 
			{
				CString value;

				if (m_pAdditionalProperties[i].acqerr == 1) 
				{
					value.Format("(read error)");
				}
				else
				{
					if (m_pAdditionalProperties[i].type == 1)
					{
						value.Format("%d", m_pAdditionalProperties[i].intval );
					}
					else
					{
						value.Format("%f", m_pAdditionalProperties[i].dblval );
					}
				}


				switch( cnt+1 )
				{
					case 1: m_CStaticProp1Text.ModifyStyle(0, WS_VISIBLE);
						    m_CEditProp1Val.ModifyStyle(0, WS_VISIBLE);
							m_CStaticProp1Unit.ModifyStyle(0, WS_VISIBLE);

						    m_CStaticProp1Text.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyName);
							m_CEditProp1Val.SetWindowText( (LPCTSTR) value ); 
							m_CStaticProp1Unit.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyUnit);
							break;

					case 2: m_CStaticProp2Text.ModifyStyle(0, WS_VISIBLE);
						    m_CEditProp2Val.ModifyStyle(0, WS_VISIBLE);
							m_CStaticProp2Unit.ModifyStyle(0, WS_VISIBLE);

							m_CStaticProp2Text.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyName);
							m_CEditProp2Val.SetWindowText( (LPCTSTR) value ); 
							m_CStaticProp2Unit.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyUnit);
							break;

					case 3: m_CStaticProp3Text.ModifyStyle(0, WS_VISIBLE);
						    m_CEditProp3Val.ModifyStyle(0, WS_VISIBLE);
							m_CStaticProp3Unit.ModifyStyle(0, WS_VISIBLE);

							m_CStaticProp3Text.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyName);
							m_CEditProp3Val.SetWindowText( (LPCTSTR) value ); 
							m_CStaticProp3Unit.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyUnit);
							break;

					case 4: m_CStaticProp4Text.ModifyStyle(0, WS_VISIBLE);
						    m_CEditProp4Val.ModifyStyle(0, WS_VISIBLE);
							m_CStaticProp4Unit.ModifyStyle(0, WS_VISIBLE);

							m_CStaticProp4Text.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyName);
							m_CEditProp4Val.SetWindowText( (LPCTSTR) value ); 
							m_CStaticProp4Unit.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyUnit);
							break;
	
					case 5: m_CStaticProp5Text.ModifyStyle(0, WS_VISIBLE);
						    m_CEditProp5Val.ModifyStyle(0, WS_VISIBLE);
							m_CStaticProp5Unit.ModifyStyle(0, WS_VISIBLE);
							
							m_CStaticProp5Text.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyName);
							m_CEditProp5Val.SetWindowText( (LPCTSTR) value ); 
							m_CStaticProp5Unit.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyUnit);
							break;

					case 6: m_CStaticProp6Text.ModifyStyle(0, WS_VISIBLE);
						    m_CEditProp6Val.ModifyStyle(0, WS_VISIBLE);
							m_CStaticProp6Unit.ModifyStyle(0, WS_VISIBLE);
							
							m_CStaticProp6Text.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyName);
							m_CEditProp6Val.SetWindowText( (LPCTSTR) value ); 
							m_CStaticProp6Unit.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyUnit);
							break;

					case 7: m_CStaticProp7Text.ModifyStyle(0, WS_VISIBLE);
						    m_CEditProp7Val.ModifyStyle(0, WS_VISIBLE);
							m_CStaticProp7Unit.ModifyStyle(0, WS_VISIBLE);
							
							m_CStaticProp7Text.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyName);
							m_CEditProp7Val.SetWindowText( (LPCTSTR) value ); 
							m_CStaticProp7Unit.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyUnit);
							break;

					case 8: m_CStaticProp8Text.ModifyStyle(0, WS_VISIBLE);
						    m_CEditProp8Val.ModifyStyle(0, WS_VISIBLE);
							m_CStaticProp8Unit.ModifyStyle(0, WS_VISIBLE);

							m_CStaticProp8Text.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyName);
							m_CEditProp8Val.SetWindowText( (LPCTSTR) value ); 
							m_CStaticProp8Unit.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyUnit);
							break;

					case 9: m_CStaticProp9Text.ModifyStyle(0, WS_VISIBLE);
						    m_CEditProp9Val.ModifyStyle(0, WS_VISIBLE);
							m_CStaticProp9Unit.ModifyStyle(0, WS_VISIBLE);

							m_CStaticProp9Text.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyName);
							m_CEditProp9Val.SetWindowText( (LPCTSTR) value ); 
							m_CStaticProp9Unit.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyUnit);
							break;

					case 10: m_CStaticProp10Text.ModifyStyle(0, WS_VISIBLE);
						     m_CEditProp10Val.ModifyStyle(0, WS_VISIBLE);
							 m_CStaticProp10Unit.ModifyStyle(0, WS_VISIBLE);

							 m_CStaticProp10Text.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyName);
							 m_CEditProp10Val.SetWindowText( (LPCTSTR) value ); 
							 m_CStaticProp10Unit.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyUnit);
							 break;

					case 11: m_CStaticProp11Text.ModifyStyle(0, WS_VISIBLE);
						     m_CEditProp11Val.ModifyStyle(0, WS_VISIBLE);
							 m_CStaticProp11Unit.ModifyStyle(0, WS_VISIBLE);

							 m_CStaticProp11Text.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyName);
							 m_CEditProp11Val.SetWindowText( (LPCTSTR) value ); 
							 m_CStaticProp11Unit.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyUnit);
							 break;

					case 12: m_CStaticProp12Text.ModifyStyle(0, WS_VISIBLE);
						     m_CEditProp12Val.ModifyStyle(0, WS_VISIBLE);
							 m_CStaticProp12Unit.ModifyStyle(0, WS_VISIBLE);

							 m_CStaticProp12Text.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyName);
							 m_CEditProp12Val.SetWindowText( (LPCTSTR) value ); 
							 m_CStaticProp12Unit.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyUnit);
							 break;

					case 13: m_CStaticProp13Text.ModifyStyle(0, WS_VISIBLE);
						     m_CEditProp13Val.ModifyStyle(0, WS_VISIBLE);
							 m_CStaticProp13Unit.ModifyStyle(0, WS_VISIBLE);

							 m_CStaticProp13Text.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyName);
							 m_CEditProp13Val.SetWindowText( (LPCTSTR) value ); 
							 m_CStaticProp13Unit.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyUnit);
							 break;

					case 14: m_CStaticProp14Text.ModifyStyle(0, WS_VISIBLE);
						     m_CEditProp14Val.ModifyStyle(0, WS_VISIBLE);
							 m_CStaticProp14Unit.ModifyStyle(0, WS_VISIBLE);

							 m_CStaticProp14Text.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyName);
							 m_CEditProp14Val.SetWindowText( (LPCTSTR) value ); 
							 m_CStaticProp14Unit.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyUnit);
							 break;

					case 15: m_CStaticProp15Text.ModifyStyle(0, WS_VISIBLE);
						     m_CEditProp15Val.ModifyStyle(0, WS_VISIBLE);
							 m_CStaticProp15Unit.ModifyStyle(0, WS_VISIBLE);

							 m_CStaticProp15Text.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyName);
							 m_CEditProp15Val.SetWindowText( (LPCTSTR) value ); 
							 m_CStaticProp15Unit.SetWindowText( (LPCTSTR) m_pAdditionalProperties[i].FriendlyUnit);
							 break;

					default: break;
				}
				cnt++;
			}
		}
	}

    // set first focus on textarea to TRUE so we can check that when the textarea becomes its first focus
    m_bFirstFocus = TRUE;
		
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// ReturnInformation() - returns the information string (that will be written 
// to file)
//
//
void CAdditionalInformation::ReturnInformation( CString &str )
{
 str = m_sInformation;
}

/////////////////////////////////////////////////////////////////////////////
// OnOk1 - OK Button pressed
//
// This function builds the return string when the user presses OK. After 
// this function, the dialog is destroyed.
// 
void CAdditionalInformation::OnOk1() 
{
    // make return string empty
	CString tmp;
	CString value;
	m_sInformation = "";

    for (int i=0;i<NUM_MAX_ADDITIONAL_PROPERTIES;i++)
	{
      if (m_pAdditionalProperties[i].enabled == TRUE)
	  {
       if (m_pAdditionalProperties[i].acqerr == FALSE)
	   {
		   if (m_pAdditionalProperties[i].type == 1) // INT
		   {
			   value.Format("%d", m_pAdditionalProperties[i].intval );
		   }
		   else // FLOAT 
		   {
			   value.Format("%f", m_pAdditionalProperties[i].dblval );
		   }
	   }
	   else
	   {
		   value.Format("(read err)");
	   }

	   if (m_pAdditionalProperties[i].FriendlyUnit == "")
	   {
			tmp.Format("%s = %s\n", m_pAdditionalProperties[i].FriendlyName, value);
	   }
	   else
	   {
			tmp.Format("%s = %s %s\n", m_pAdditionalProperties[i].FriendlyName, value, m_pAdditionalProperties[i].FriendlyUnit);
	   }
	  
	   m_sInformation += tmp;
	  
	  }

	}


    // add laser pulses
	m_CEditLaserPulses.GetWindowText( tmp );
	if (tmp == "") tmp = "(not entered)";
	m_sInformation += "Laser pulses = "+tmp+"\n";

    // add charge at diagnostic cross
	m_CEditChargeDC.GetWindowText( tmp );
	if (tmp == "") tmp = "(not entered)";
	m_sInformation += "Charge at DC [nC] = "+tmp+"\n";

    // add charge at straight section
	m_CEditChargeSS.GetWindowText( tmp );
	if (tmp == "") tmp = "(not entered)";
	m_sInformation += "Charge at Str. S. [nC] = "+tmp+"\n";

    // add spot size at virtual cathode
	m_CEditSpotSizeVC.GetWindowText( tmp );
	if (tmp == "") tmp = "(not entered)";
	m_sInformation += "Spot size at Virtual Cathode = "+tmp+"\n";

    // add number of amplifiers
	m_CEditNumAmp.GetWindowText( tmp );
	if (tmp == "") tmp = "(not entered)";
	m_sInformation += "Number of Amplifiers = "+tmp+"\n";

    // add camera gain
	m_CEditCameraGain.GetWindowText( tmp );
	if (tmp == "") tmp = "(not entered)";
	m_sInformation += "Camera gain = "+tmp+"\n";

    if (m_bFirstFocus == FALSE) // something has been entered in the textarea
	{
	 // save it also 
	 m_CEditInformation.GetWindowText( tmp );
     m_sInformation += "\nAdditional Information:\n"+tmp;
	}
	
	// call base class
	CDialog::OnOK();
}

/////////////////////////////////////////////////////////////////////////////
// OnSetfocusEditAdditional - called whenever the textarea gets the focus
//
// If the textarea is getting the first focus, then clear the textarea.
// 
void CAdditionalInformation::OnSetfocusEditAdditional() 
{
    if (m_bFirstFocus == TRUE)
	{
	 m_CEditInformation.SetWindowText("");
	 m_bFirstFocus = FALSE;
	}	
}

void CAdditionalInformation::OnOKAuto()
{
    // make return string empty
	CString tmp;
	CString value;
	m_sInformation = "";

    for (int i=0;i<NUM_MAX_ADDITIONAL_PROPERTIES;i++)
	{
      if (m_pAdditionalProperties[i].enabled == TRUE)
	  {
       if (m_pAdditionalProperties[i].acqerr == FALSE)
	   {
		   if (m_pAdditionalProperties[i].type == 1) // INT
		   {
			   value.Format("%d", m_pAdditionalProperties[i].intval );
		   }
		   else // FLOAT 
		   {
			   value.Format("%f", m_pAdditionalProperties[i].dblval );
		   }
	   }
	   else
	   {
		   value.Format("(read err)");
	   }

	   if (m_pAdditionalProperties[i].FriendlyUnit == "")
	   {
			tmp.Format("%s = %s\n", m_pAdditionalProperties[i].FriendlyName, value);
	   }
	   else
	   {
			tmp.Format("%s = %s %s\n", m_pAdditionalProperties[i].FriendlyName, value, m_pAdditionalProperties[i].FriendlyUnit);
	   }
	  
	   m_sInformation += tmp;
	  
	  }

	}

}

