#if !defined(AFX_ADDITIONALINFORMATION_H__9CA0B226_AAB9_11D6_AFBD_0002B34B0F4F__INCLUDED_)
#define AFX_ADDITIONALINFORMATION_H__9CA0B226_AAB9_11D6_AFBD_0002B34B0F4F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// AdditionalInformation.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CAdditionalInformation dialog

class CAdditionalInformation : public CDialog
{
// Construction
public:
	void OnOKAuto();
	CAdditionalInformation(int numprops, struct AdditionalProperty *addprops, CWnd* pParent = NULL);   // standard constructor
    
	// return information data as string that can be written directly to a txt file
	void ReturnInformation( CString &str );
    
	// sets the data that was automatically read out by another part of the program
	//void SetData( double spvoltage, double spphase, double klystronfwp, double gunfwp, double gunrefl, 
	//              double gungradient, double imain, double ibuck, double dipole);

// Dialog Data
	//{{AFX_DATA(CAdditionalInformation)
	enum { IDD = IDD_DIALOG1 };
	CEdit	m_CEditProp15Val;
	CEdit	m_CEditProp14Val;
	CEdit	m_CEditProp13Val;
	CEdit	m_CEditProp12Val;
	CEdit	m_CEditProp11Val;
	CEdit	m_CEditProp8Val;
	CEdit	m_CEditProp7Val;
	CEdit	m_CEditProp4Val;
	CEdit	m_CEditProp10Val;
	CEdit	m_CEditProp6Val;
	CEdit	m_CEditProp9Val;
	CEdit	m_CEditProp5Val;
	CEdit	m_CEditProp3Val;
	CEdit	m_CEditProp2Val;
	CEdit	m_CEditProp1Val;
	CStatic	m_CStaticProp9Unit;
	CStatic	m_CStaticProp8Unit;
	CStatic	m_CStaticProp7Unit;
	CStatic	m_CStaticProp6Unit;
	CStatic	m_CStaticProp5Unit;
	CStatic	m_CStaticProp4Unit;
	CStatic	m_CStaticProp3Unit;
	CStatic	m_CStaticProp2Unit;
	CStatic	m_CStaticProp15Unit;
	CStatic	m_CStaticProp14Unit;
	CStatic	m_CStaticProp13Unit;
	CStatic	m_CStaticProp12Unit;
	CStatic	m_CStaticProp11Unit;
	CStatic	m_CStaticProp10Unit;
	CStatic	m_CStaticProp1Unit;
	CStatic	m_CStaticProp9Text;
	CStatic	m_CStaticProp8Text;
	CStatic	m_CStaticProp6Text;
	CStatic	m_CStaticProp7Text;
	CStatic	m_CStaticProp5Text;
	CStatic	m_CStaticProp4Text;
	CStatic	m_CStaticProp3Text;
	CStatic	m_CStaticProp2Text;
	CStatic	m_CStaticProp15Text;
	CStatic	m_CStaticProp14Text;
	CStatic	m_CStaticProp13Text;
	CStatic	m_CStaticProp12Text;
	CStatic	m_CStaticProp11Text;
	CStatic	m_CStaticProp10Text;
	CStatic	m_CStaticProp1Text;

	CEdit	m_CEditLaserPulses;
	CEdit	m_CEditNumAmp;
	CEdit	m_CEditSpotSizeVC;
	CEdit	m_CEditChargeSS;
	CEdit	m_CEditChargeDC;
	CEdit	m_CEditCameraGain;
	CEdit	m_CEditInformation;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAdditionalInformation)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CAdditionalInformation)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnOk1();
	afx_msg void OnSetfocusEditAdditional();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	//CCATineDlg * m_pTineDlg;
	int m_iNumProperties;
	struct AdditionalProperty * m_pAdditionalProperties;

    // TRUE: doocs values were set
	//BOOL m_bDoocsValuesSet;
	
	// TRUE: the textarea becomes the first focus
	BOOL m_bFirstFocus;

    // information string (that will be written to file)
	CString m_sInformation;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ADDITIONALINFORMATION_H__9CA0B226_AAB9_11D6_AFBD_0002B34B0F4F__INCLUDED_)
