// EnvelopeAverageChoose.cpp : implementation file
//

#include "stdafx.h"
#include "videoclnt.h"
#include "EnvelopeAverageChoose.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEnvelopeAverageChoose dialog


CEnvelopeAverageChoose::CEnvelopeAverageChoose(CWnd* pParent /*=NULL*/)
	: CDialog(CEnvelopeAverageChoose::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEnvelopeAverageChoose)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CEnvelopeAverageChoose::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEnvelopeAverageChoose)
	DDX_Control(pDX, IDC_RADIO1, m_CCheckEnvelope);
	DDX_Control(pDX, IDC_RADIO2, m_CCheckAverage);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEnvelopeAverageChoose, CDialog)
	//{{AFX_MSG_MAP(CEnvelopeAverageChoose)
	ON_BN_CLICKED(IDC_RADIO2, OnRadioAverage)
	ON_BN_CLICKED(IDC_RADIO1, OnRadioEnvelope)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEnvelopeAverageChoose message handlers

static int avg=1;

void CEnvelopeAverageChoose::OnRadioAverage() 
{
	m_CCheckAverage.SetCheck(1);
	m_CCheckEnvelope.SetCheck(0);

	avg = 1;
	
}

void CEnvelopeAverageChoose::OnRadioEnvelope() 
{
	m_CCheckAverage.SetCheck(0);
	m_CCheckEnvelope.SetCheck(1);

	avg = 0;
	
}

void CEnvelopeAverageChoose::OnOK() 
{
	CDialog::OnOK();
}

BOOL CEnvelopeAverageChoose::OnInitDialog() 
{
	CDialog::OnInitDialog();

	if (avg == 0)
	{
  		m_CCheckAverage.SetCheck(0);
		m_CCheckEnvelope.SetCheck(1);
	}
	else
	{
		m_CCheckAverage.SetCheck(1);
		m_CCheckEnvelope.SetCheck(0);
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


int CEnvelopeAverageChoose::ReturnChoiceAverage()
{
 return( avg );
}

int CEnvelopeAverageChoose::ReturnChoiceEnvelope()
{
 return( 1-avg );
}
