// MessagesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "videoclnt.h"
#include "headers.h"
#include <math.h>
#include <vfw.h>
#include "Queue.h"
#include "compression.h"
class CVideoclntDlg;
#include <windows.h>
#include <winsock.h>
#undef fd_set
#include "CATineDlg.h"
#include "TineALDlg.h"
#include "ImageSequence.h"
#include "IniEx.h"
#include "SSyncSocket.h"
#include "configdlg.h"
#include "Server.h"
#include "ServerList.h"
#include "MessagesDlg.h"
#include "BogusTineDlg.h"
#include "ImageAcquire.h"
#include "Stat.h"
#include "FourierStat.h"
#include "StatFile.h"
#include "MyVideoFrame.h"
#include "PrinterSettings.h"
#include "MarkedComboBox.h"
#include "InformationDialog.h"
#include "videoclntDlg.h"
#include "acop.h"
#include "oleauto.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMessagesDlg dialog
//
// This dialog shows some messages the program outputs. Under normal condition, 
// the user does not need to open the messages dialog. But under some rare error 
// conditions one is (mostly) able to find out what was going wrong. At least the 
// user can send the log to the programmer. The programmer can then analyse it.
//

// Standard construction of CDialog
CMessagesDlg::CMessagesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMessagesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMessagesDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_pMainDlg = NULL;
}


void CMessagesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMessagesDlg)
	DDX_Control(pDX, IDC_EDIT2, m_CEditMessages);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMessagesDlg, CDialog)
	//{{AFX_MSG_MAP(CMessagesDlg)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMessagesDlg message handlers

/////////////////////////////////////////////////////////////////////////////
// This function is called if the user presses the 'X' (Close) on the title bar of 
// the messages dialog.
//
void CMessagesDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default

	// tell main program not to send messages to us any more, because we are not able to display them
	m_pMainDlg->SetMessagesWindowStatus(); 

	// call base-class
	CDialog::OnClose();
}

/////////////////////////////////////////////////////////////////////////////
// This function sets the main dialog pointer, so that we can later call some 
// of the public functions from the main program.
//
void CMessagesDlg::SetMainDlg(CVideoclntDlg *the_dlg)
{
 m_pMainDlg = the_dlg;
}

/////////////////////////////////////////////////////////////////////////////
// This function prints out the actual message, which is delivered in the 
// parameter 'message'.
//
void CMessagesDlg::PrintServerMessage(CString message)
{
  CString str;
  CString brk = CString("\r\n");

  // append the new message to the old messages
  m_CEditMessages.GetWindowText(str);

  int numlines = 0;
  int pos = 0;
  int foundpos;

  while( (foundpos = str.Find( "\r\n", pos) ) != -1)
  {
   pos = foundpos + 2;
   numlines++;
  }

  if (numlines > 599)
  {
   str = str.Right( str.GetLength() - str.Find("\r\n", 0 ) - 2 );
  }

  str += message;
  str += brk;
  m_CEditMessages.SetWindowText( str );
  
  // jump to last line, otherwise the messages will be displayed starting at the first line
  m_CEditMessages.LineScroll( m_CEditMessages.GetLineCount() );
}
