//{{AFX_INCLUDES()
#include "acop.h"
//}}AFX_INCLUDES
#if !defined(AFX_TINEALDLG_H__552FC32E_AF45_47E2_955B_DBE69F1C2D5A__INCLUDED_)
#define AFX_TINEALDLG_H__552FC32E_AF45_47E2_955B_DBE69F1C2D5A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// TineALDlg.h : header file
//



/////////////////////////////////////////////////////////////////////////////
// CTineALDlg dialog

class CTineALDlg : public CDialog
{
// Construction
public:
	
	CTineALDlg(CWnd* pParent = NULL);   // standard constructor

	BOOL DeinitializeTine();
	BOOL InitializeTine( CVideoclntDlg *maindlg, AdditionalProperty *addprops);

	BOOL returnWholePropertyStringForDAQ( CString &propStr );
    BOOL returnWholePropertyDescriptionStringForDAQ( CString &propdescStr );

	BOOL returnDAQPropAsDouble( int prop, double &val);
	BOOL returnDAQPropAsInt( int prop, int &val);
	BOOL returnDAQPropAsString( int prop, CString &val); // empty up to now !!!
	BOOL returnDAQPropDescAsString( int prop, CString &val);
	BOOL returnDAQPropAsInterpretedString( int prop, CString &val);

    BOOL snapshotAdditionalPropertiesToAdditionalPropertyStructure();

// Dialog Data
	//{{AFX_DATA(CTineALDlg)
	enum { IDD = IDD_DIALOG_TINEAL };
	CACOP	m_CACOPAL;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTineALDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CTineALDlg)
	afx_msg void OnReceiveAcopctrlAL(long LinkIndex, long StatusCode);
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	CVideoclntDlg * m_pMainDlg;
	BOOL m_bSuccessfulInitialized;

	VARIANT m_daqprop_var[NUM_MAX_DAQ_PROPERTIES];
	VARIANT m_daqprop_var_ro[NUM_MAX_DAQ_PROPERTIES];
	BOOL    m_daqprop_read[NUM_MAX_DAQ_PROPERTIES];
	long    m_daqprop_linkid[NUM_MAX_DAQ_PROPERTIES];

	// TINE 
	long    m_daqprop_datatype[NUM_MAX_DAQ_PROPERTIES];
	CString m_daqprop_context[NUM_MAX_DAQ_PROPERTIES];
	CString m_daqprop_server[NUM_MAX_DAQ_PROPERTIES];
	CString m_daqprop_device[NUM_MAX_DAQ_PROPERTIES];
	CString m_daqprop_property[NUM_MAX_DAQ_PROPERTIES];

	CString m_daqprop_unit_str[NUM_MAX_DAQ_PROPERTIES];
	CString m_daqprop_name_str[NUM_MAX_DAQ_PROPERTIES];

	// --------------------------------------


	VARIANT m_addprop_var[NUM_MAX_ADDITIONAL_PROPERTIES];
	VARIANT m_addprop_var_ro[NUM_MAX_ADDITIONAL_PROPERTIES];
	BOOL    m_addprop_read[NUM_MAX_ADDITIONAL_PROPERTIES];
	BOOL    m_addprop_enabled[NUM_MAX_ADDITIONAL_PROPERTIES];
	long    m_addprop_linkid[NUM_MAX_ADDITIONAL_PROPERTIES];

	// TINE 
	long    m_addprop_datatype[NUM_MAX_ADDITIONAL_PROPERTIES];
	CString m_addprop_context[NUM_MAX_ADDITIONAL_PROPERTIES];
	CString m_addprop_server[NUM_MAX_ADDITIONAL_PROPERTIES];
	CString m_addprop_device[NUM_MAX_ADDITIONAL_PROPERTIES];
	CString m_addprop_property[NUM_MAX_ADDITIONAL_PROPERTIES];

	CString m_addprop_unit_str[NUM_MAX_ADDITIONAL_PROPERTIES];
	CString m_addprop_name_str[NUM_MAX_ADDITIONAL_PROPERTIES];
	

	int m_iLoadedAdditionalProperties;
	
	int m_iLoadedDAQProperties;

	AdditionalProperty *m_pAdditionalProperties;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TINEALDLG_H__552FC32E_AF45_47E2_955B_DBE69F1C2D5A__INCLUDED_)
