#if !defined(AFX_CONFIGDLG_H__9CF14EE3_5E63_11D6_AFA3_0002B34B0F4F__INCLUDED_)
#define AFX_CONFIGDLG_H__9CF14EE3_5E63_11D6_AFA3_0002B34B0F4F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ConfigDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CConfigDlg dialog

class CConfigDlg : public CDialog
{
// Construction
public:
	// standard construction
	// pass nref, pref and parent window reference
	CConfigDlg(int nref0, int pref0, CWnd* pParent = NULL);   // standard constructor

	// sets reference to the CIniEx object (permanent settings)
	void setConfiguration( CIniEx *the_config );

// Dialog Data
	//{{AFX_DATA(CConfigDlg)
	enum { IDD = IDD_CONFIGDLG_DIALOG };
	CEdit	m_CEditImaqInterface;
	CEdit	m_CEditTineFrameServer;
	CEdit	m_CEditTinePort;
	CEdit	m_CEditTineControlServer;
	CEdit	m_CEditTineContext;
	CSliderCtrl	m_CSliderJPEGQuality;
	CEdit	m_CEditJPEGQuality;
	CEdit	m_CEditPRef0;
	CEdit	m_CEditNRef0;
	CButton	m_CCheckTrigMod5;
	CButton	m_CCheckExtTrig;
	CButton	m_CCheckLossy;
	CEdit	m_CEditNumberClientsLossy;
	CEdit	m_CEditPortnumberLossy;
	CEdit	m_CEditNumberClients;
	CEdit	m_CEditPortnumber;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CConfigDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CConfigDlg)
	virtual void OnOK();
	virtual void OnCancel();
	virtual BOOL OnInitDialog();
	afx_msg void OnCheck1();
	afx_msg void OnCheck2Exttrig();
	afx_msg void OnCheck3Trigmod5();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void mkreOrientation( int value, CString &valuestr );
	int mkOrientation( CString value );
	// checks for validity of the parameters on the configuration dialog
	// TRUE: all parameters are valid
	// FALSE: one or some parameters are invalid
	BOOL CheckParameters();

    // reference to the CIniEx object (permanent settings)
    CIniEx *m_pIniFile;
	
	// positive and negative reference (view only on the dialog)
	int m_iPRef;
	int m_iNRef;


	CString m_sTineContext;
	CString m_sTineControlServer;
	CString m_sTineFrameServer;
	int m_iTinePort;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CONFIGDLG_H__9CF14EE3_5E63_11D6_AFA3_0002B34B0F4F__INCLUDED_)
