// JPEGCompression.h: interface for the CJPEGCompression class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_JPEGCOMPRESSION_H__8A9C57DE_D750_448C_B846_E52F70A3F9EA__INCLUDED_)
#define AFX_JPEGCOMPRESSION_H__8A9C57DE_D750_448C_B846_E52F70A3F9EA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CJPEGCompression  
{
public:
	int GetMaxCompressedSize();
	BOOL Done();
	BOOL Init(int width, int height);
	void SetQuality( int quality );
	BOOL Compress( char *aktframe_uncompressed, VIDHDR vidH, char *aktframe_jpegcompressed, int *jpeg_length, CString cportstr);
	CJPEGCompression();
	virtual ~CJPEGCompression();

private:
	BOOL m_bSuccessfullyInitialized;
	int m_iHeight;
	int m_iWidth;
	int m_iQuality;
};

#endif // !defined(AFX_JPEGCOMPRESSION_H__8A9C57DE_D750_448C_B846_E52F70A3F9EA__INCLUDED_)
