#ifndef __STRINGFUNC_H_INCLUDED__
#define __STRINGFUNC_H_INCLUDED__


	#define MAX_STRING_LENGTH   600
	#define MAX_PATH_LENGTH     255

	void	copywholestring(char *dest, const char *src);
	int		find( const char *str, const char *search);
	int		reversefind( const char *str, int c );
	void	Left(char *dest, const char *src, int num);
	void	Mid( char *dest, const char *src, int left, int count);
	void	Mid( char *dest, const char *src, int left);
	void	Right( char *dest, const char *src, int num);
	BOOL	isLeftmostChar(const char *str, int c);
	BOOL	isRightmostChar( const char *str, int c);
	void	addstr( char *dest, const char *add);
	int		IsEmpty( char *str );
	int		ReadStringInt(FILE *fp, char *line);
	BOOL	ReadString(FILE *fp, char *line);
	void	TrimRight(char *line, char *defaultset=" \n\t");
	int		DeleteString( char *string, int nIndex, int nCount=1);


	BOOL	Add( char **stringarray, const char *string );

	//		-1 for failure
	int		GetUpperBound( const char *stringarray );

	//		0 for failure
	int		GetSize( const char *stringarray );

	char   *GetAt( const char *stringarray, int index);
	void	SetAt( char **stringarray, int index, const char *value);
	void    SetAtGrow( char **stringarray, int index, const char *value);
	
	BOOL	RemoveAt(char **stringarray, int index);


#endif