#if !defined(AFX_CONFIGDLG_H__96D74B26_6970_11D6_AFB0_0002B34B0F4F__INCLUDED_)
#define AFX_CONFIGDLG_H__96D74B26_6970_11D6_AFB0_0002B34B0F4F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ConfigDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CConfigDlg dialog

class CConfigDlg : public CDialog
{
// Construction
public:
	CConfigDlg(CWnd* pParent = NULL);   // standard constructor

    // returns whether the server data structures should be reinitilaized    
	BOOL ReturnServerReInititialisation();
	
	// returns choosed transfer mode (TRUE: tine, FALSE: sockets)
	BOOL ReturnTransferMode();
	
	// set tine boolean variables before dialog is created
	void SetTineProperties( BOOL IsTineEnabled, BOOL CanTineBeEnabled);
	
	// sets the ini file references before dialog is created
	void SetIniFile( CIniEx *the_ini_exe_global, CIniEx *the_ini_exe_local, CIniEx *the_ini_prof);

	// Dialog Data
	//{{AFX_DATA(CConfigDlg)
	enum { IDD = IDD_DIALOG1_CONFIG };
	CButton	m_CCheckFilePreviewDisabled;
	CEdit	m_CEditDAQDir;
	CEdit	m_CEditDAQFile;
	CButton	m_CRadioSockets;
	CButton	m_CRadioTine;
	CButton	m_CButtonEnableReInit;
	CComboBox	m_CComboFramerate;
	CEdit	m_CEditSnapshot;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CConfigDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CConfigDlg)
	virtual void OnOK();
	virtual void OnCancel();
	virtual BOOL OnInitDialog();
	afx_msg void OnChooseSnapshot();
	afx_msg void OnButton2Enablereinit();
	afx_msg void OnRadio1Tine();
	afx_msg void OnRadio2Sockets();
	afx_msg void OnButton2Daqfile();
	afx_msg void OnButton3Daqdir();
	afx_msg void OnCheckDisabledFilePreviewDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	int CheckDirectory( CString dir);
	// TRUE: tine multicase, FALSE: sockets
	BOOL m_bTransferModeTine;
	// TRUE: tine can be enabled, FALSE: must use sockets
	BOOL m_bCanTineBeEnabled;
	// TRUE: tine is enabled, FALSE: tine is not enabled but can be enabled
	BOOL m_bIsTineEnabled;

    // TRUE: server data structures should be re-initalized
	BOOL m_bReInit;

    // reference to the two initialization files
	CIniEx * m_pIniFileExeGlobal; // at executables directory
	CIniEx * m_pIniFileExeLocal; // at executables directory
    CIniEx * m_pIniFileProf; // at user's profile directory
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CONFIGDLG_H__96D74B26_6970_11D6_AFB0_0002B34B0F4F__INCLUDED_)
