// EnvelopeAverage.h: interface for the CEnvelopeAverage class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ENVELOPEAVERAGE_H__0F032257_7D83_465E_AF51_8324093F371D__INCLUDED_)
#define AFX_ENVELOPEAVERAGE_H__0F032257_7D83_465E_AF51_8324093F371D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CEnvelopeAverage  
{
public:
	CEnvelopeAverage();
	virtual ~CEnvelopeAverage();


BOOL CEnvelopeAverage::Init( unsigned int bpp, VIDHDR vidH, BOOL envelope, BOOL xray );
BOOL CEnvelopeAverage::AddFrame( unsigned char *frame, VIDHDR vidH);
void CEnvelopeAverage::ReturnBuffer( unsigned char *outbuffer, unsigned int *size );
void CEnvelopeAverage::Done();

private:
    void XFilter(unsigned char *data, int width, int height);
    unsigned int m_iCount;
	unsigned int m_iHeight;
	unsigned int m_iWidth;
    unsigned int m_iBpp;
	unsigned int *m_pBuffer816;
	double *m_pBuffer32;
	BOOL m_bEnvelope;
	BOOL m_bSuccessfullyInitialized;
	BOOL m_bXRay;
};

#endif // !defined(AFX_ENVELOPEAVERAGE_H__0F032257_7D83_465E_AF51_8324093F371D__INCLUDED_)
