// FitParam.h: interface for the FitParam class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FITPARAM_H__E2F499D3_6780_11D7_92C9_000102FA37F9__INCLUDED_)
#define AFX_FITPARAM_H__E2F499D3_6780_11D7_92C9_000102FA37F9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class Component{
public:
	Component(){}
	double UpperLimit;
	double LowerLimit;
	double CurrentValue;
};

class FitParam  
{
public:
	FitParam(int left, int up, int right, int down, double FTMeanX, double FTMeanY, double MinXDIST, double MaxXDIST, double MinYDIST, double MaxYDIST, double sigma_X, double sigma_Y, double offset_X, double offset_Y, BOOL XY);
	Component* FitPar;
	int TotalNumber;
	FitParam();
	FitParam& operator = (FitParam& EQV);
      void  VM (FitParam* fV);
	virtual ~FitParam();

};

#endif // !defined(AFX_FITPARAM_H__E2F499D3_6780_11D7_92C9_000102FA37F9__INCLUDED_)
